-- 
--
--                      European Air War 
--                        import / export
--      "3DZ" format convertet into ASCII txt file
--                    by till 'rollin' maginot
--                        till.maginot.eu
--                           (c) 2009
--
-- v 0.9.2

 
-- #####################################################################################################################


-- #######################

( -- START ALL


	-- functions forward declaration
	local MakeNumber;
	local getUVfromPolyVert
	local getVertOrder;
	local getEdgesBetween2Verts;
	local setPolyEdgeVis;
	local normal2rotation;
	local rotation2normal;
	local makeEawNormal;
	local getPolyArray;
	local getPolyVertexArray;
	local getPolyVertexCoordinatesArray;
	local getHPinfo;
	
	local absoluteJoin;
	local RS_pointRelPositionCheck;
	local RS_check_coplanar;
	local RS_check_mesh_coplanar;
	local RS_makePositionP3;
	local RS_polyPositionCalc;
	local RS_polyPositionSimpleCalc;
	local RS_allPolyPosCalc;
	local RS_HPtoFakePoly;
	
	local RS_treeCalc;
	local RS_makeRS;
	
	local importTXT;
	local exportTXT;
	-- end function forward declaration



-- this marks all function which do call ather function of this script
-- FUNCTION CALL == FC


--  support FUNCTIONS import / export


function MakeNumber nr = (
	
	-- 001 , 011, 111
	if nr as integer <10 then n00 = "00";
	else (
		if nr as integer < 100 then n00 = "0";
	)
	if nr as integer > 99 then n00 = "";
		
	return (n00 + nr as string);
	
)


function getUVfromPolyVert getMesh getPolyFace_array getVertID = (
	
	
	-- looks through all faces of one poly and search for one that shares the same vertex as we are looking for
	-- then gets the number of this vertex on the face 1, 2 or 3 and loads the corresponding textur-vertex-uvw-coordinates
	
	--print "function  getUVfromPolyVert";
	--format  "getMesh = % \n" getMesh;
	--print "getPolyFace_array";
	--print getPolyFace_array;
	-- format "getVertID = % \n" getVertID;
	
	if getMesh != undefined and getPolyFace_array != undefined and getVertID != undefined then (
	
		local searchedTvertID;
		for i=1 to getPolyFace_array.count do (
			local thisFaceTverts = meshop.getMapFace getMesh 1 getPolyFace_array[i];
			--print "_ thisFaceTverts = ";
			--print thisFaceTverts;
			local thisFaceVerts = getFace getMesh getPolyFace_array[i];
			--print "_ thisFaceVerts = ";
			--print thisFaceVerts;
			
			-- format "this Face Vert1 = % , Vert2 = % , Vert3 = % \n" thisFaceVerts.x thisFaceVerts.y thisFaceVerts.z
			
			if thisFaceVerts.x == getVertID then ( searchedTvertID = thisFaceTverts.x; exit;)
			if thisFaceVerts.y == getVertID then ( searchedTvertID = thisFaceTverts.y; exit;)
			if thisFaceVerts.z == getVertID then ( searchedTvertID = thisFaceTverts.z; exit;)
		)
		
		local tmpReturn;
		if searchedTvertID != undefined then (
			tmpReturn = meshop.getMapVert getMesh 1 searchedTvertID;
			tmpReturn.x =  (tmpReturn.x * 254);
			tmpReturn.y =  (tmpReturn.y * 254);
			tmpReturn.z =  (tmpReturn.z * 254);
			return tmpReturn;
		)
	)
)


function getVertOrder getMesh getPolyFace_array = (
	
	-- gets for every face of the poly the 3 vertices and builds edge-representation as (v1,v2)==edge1 ... (v2,v3)==edge2 ... (v3,v1) ==edge3
	-- then connects all the 'edges' of all faces from one poly together like domino briks so that we get somethin like (v1,v2,v3......)
	
	
	--print "function getVertOrder";
	
	local visibleEdgeList = #();
	local vertsOfThisPoly = #{};
	
	-- for every face from this poly
	for i=1 to getPolyFace_array.count do (
		local vertsOfThisFace;
		--format "\n checking face % \n" getPolyFace_array[i] ; 
		vertsOfThisFace = getFace getMesh getPolyFace_array[i];
		--print "vertsOfThisFace :: ";
		--print vertsOfThisFace;
		
		vertsOfThisPoly += #(vertsOfThisFace.x,  vertsOfThisFace.y, vertsOfThisFace.z)as bitarray;
		
		-- create visibleEdgeList
		local edgeVisibilityOfThisFace = #();
		for j=1 to 3 do (
			-- format "checking edge % :: \n" j;
			edgeVisibilityOfThisFace[j] = (getEdgeVis getMesh getPolyFace_array[i] j);
			
			if edgeVisibilityOfThisFace[j] then (
				if j < 3 then (
					 append visibleEdgeList #( vertsOfThisFace[j] , vertsOfThisFace[j+1] );
				)
				if j == 3 then (
					append visibleEdgeList #( vertsOfThisFace[3] , vertsOfThisFace[1] );
				)
			)
		)
		-- print " _ visibleEdgeList :: ";
		--print visibleEdgeList;
		
	)
	
	--print "vertsOfThisPoly :: ";
	--print vertsOfThisPoly;
	
	-- debugging
	-- there should be always as much edges as vertices
	-- connect all 'edges' to one vertexOrder together
		tmpDifference = visibleEdgeList.count - ((vertsOfThisPoly as array).count);
	if  tmpDifference == 0 then (
		
		-- create thisPolyVertOrder array
		local thisPolyVertOrder = #();
		thisPolyVertOrder[1] = visibleEdgeList[1][1] as integer;
		
		for i=1 to visibleEdgeList.count do (
			
			for j=1 to visibleEdgeList.count do (
				if thisPolyVertOrder[i] == visibleEdgeList[j][1] then (
					thisPolyVertOrder[i+1] = visibleEdgeList[j][2] as integer;
					exit;
				)
			)
		)
		--print " _ thisPolyVertOrder ::";
		--print thisPolyVertOrder;
		--print "- remove last, double entry"
		deleteItem thisPolyVertOrder thisPolyVertOrder.count;
		return thisPolyVertOrder;
	)
	else (
		print "!!! ERROR !!! -- bad poly found - build from these faces :: ";
		print getPolyFace_array;
		print "!!!!!!!!!!!!!!!____________________________!!!!!!!!!!!!!!!!";
	)
	
)


function getEdgesBetween2Verts getMesh getVerts = (
	
	--print "function getEdgesBetween2Verts";
	local foundEdges = #();
	if getVerts.count == 2 then (
		
		selectedEdges = (meshop.getEdgesUsingVert getMesh getVerts) as array;
		--print " _ selectedEdges :: ";
		--print selectedEdges;
		
		for i=1 to selectedEdges.count do (
			--format "looking at edge % \n" i;
			vertsOfThisEdge = meshop.getVertsUsingEdge getMesh selectedEdges[i];
			--print " _ vertsOfThisEdge :: ";
			--print vertsOfThisEdge;
			if (vertsOfThisEdge - (getVerts as bitarray) ).isEmpty then (
				--format "edge between vertices is % \n" selectedEdges[i];
				append foundEdges selectedEdges[i];
			)
		)
		return foundEdges;
	)
	else print "please select only 2 verts at once";
)

-- FC :: getEdgesBetween2Verts
function setPolyEdgeVis getMesh getPolyFace_array = (
	
	--startTime = timeStamp();
	
	--print "function setPolyEdgeVis";
	-- set visible edges -- important for the following calculations and debugging function
	-- make sure, that all outer edges of an poly are visible and all inter edges are invisible
	-- for every poly of this mesh
	
	
	
	-- check if any modifiers are present
	-- if yes stop this function
	--modPanel.setCurrentObject getMesh.baseObject; this slows down the function A LOOOOT !!!
	if getMesh.modifiers.count > 0 then (
		-- print ("please remove all modifiers from this object ::" + getMesh as string);
		return false;
	)
	

	
	-- here are the verts stored.. edges between them should be switched to invisible.. all other edges not
	edgeInvisible_array = #();
	
		
	-- for every face of this poly
	for j=1 to getPolyFace_array.count do (
		
		-- edgesOfThisFace = (meshop.getEdgesUsingFace getMesh getPolyFace_array[j]) as array;
		
		--format "looking at face % \n" getPolyFace_array[j];
		
		vertsOfThisFace = getFace getMesh getPolyFace_array[j];
		
			
		
		
			-- for every of the 3 (double)edges
			for k=1 to 3 do (
				
				--format "looking at edge % \n" k;
				if k == 1 then (
					edgesOfThisFace = getEdgesBetween2Verts getMesh #(vertsOfThisFace.x, vertsOfThisFace.y);
					--format "this edge end on the verts % and % \n"  vertsOfThisFace.x vertsOfThisFace.y;
					vertA = vertsOfThisFace.x;
					vertB = vertsOfThisFace.y;
				)
				if k == 2 then (
					edgesOfThisFace = getEdgesBetween2Verts getMesh #(vertsOfThisFace.y, vertsOfThisFace.z);
					--format "this edge end on the verts % and % \n"  vertsOfThisFace.y vertsOfThisFace.z;
					vertA = vertsOfThisFace.y;
					vertB = vertsOfThisFace.z;
				)
				if k == 3 then (
					edgesOfThisFace = getEdgesBetween2Verts getMesh #(vertsOfThisFace.z, vertsOfThisFace.x);
					--format "this edge end on the verts % and % \n"  vertsOfThisFace.z vertsOfThisFace.x;
					vertA = vertsOfThisFace.z;
					vertB = vertsOfThisFace.x;
				)
						
				facesUsingThisEdge = (meshop.getFacesUsingEdge getMesh edgesOfThisFace) as array;
				--print " _ facesUsingThisEdge :: ";
				--print facesUsingThisEdge;
				
				isInside = true;
				-- if all adjacenct faces are part of the poly make this edge invisible -- if not make it visible
				-- for every adjacent face --- normaly this goes from 1 to 2
				
				if facesUsingThisEdge.count != 2 then (
					--format "edge has no further connecting faces... => set edge % to visible\n" k;
					--print " or edge has more then one connecting faces => set edge to visible";
					isInside = false;
				)
				if facesUsingThisEdge.count == 2 then (
					-- check if both faces are part of the poly
					-- for every of the ascendent faces
					for m=1 to facesUsingThisEdge.count do (
						-- for every face of this poly
						-- if both faces are part of the poly then the edge must lie within the poly and so it has to be invisible
						if (finditem getPolyFace_array facesUsingThisEdge[m]) == 0  then (
							--format "face % is NOT part of the poly % \n" facesUsingThisEdge[m] getPolyFace_array;
							isInside = false;
						)
						--else 	format "face % is part of the poly \n" facesUsingThisEdge[m];
					)
				)
				
				
				if isInside then (
					tmp1 = #{vertA, vertB} as array
					tmp2 = [tmp1[1], tmp1[2]]
					
						if (finditem edgeInvisible_array tmp2) == 0 then (
							append edgeInvisible_array tmp2;
						)
				)
			)
	)
	
	--print " _ edgeInvisible_array :: ";
	--print edgeInvisible_array;
	
	-- for every face (of this poly)
	-- get the 3 verts
	-- get the 3 edges as (vert1,vert2) (vert2,vert3) (vert3,vert1)
	-- check for every edge if it is within the edgeInvisible_array
	-- if yes-> make invisible .... if not -> make visible
	for j=1 to getPolyFace_array.count do (
		
		--print "found no match -> turn edge visible";format "working on face % \n" getPolyFace_array[j];
		vertsOfThisFace = getFace getMesh getPolyFace_array[j];
		edgesOfThisFace = #( #{vertsOfThisFace.x, vertsOfThisFace.y}, #{vertsOfThisFace.y, vertsOfThisFace.z}, #{vertsOfThisFace.z, vertsOfThisFace.x})
		
		for k=1 to 3 do (
			foundMatch = false;
			-- for every 'double'edge which should be invisible 
			for m=1 to  edgeInvisible_array.count do (
				--print "compare";
				--print edgesOfThisFace[k];
				--print #{edgeInvisible_array[m].x, edgeInvisible_array[m].y};
				if ( edgesOfThisFace[k] - #{edgeInvisible_array[m].x, edgeInvisible_array[m].y} ).isEmpty then (
					foundMatch = true;
					exit;
				)
			)
			
			if foundMatch then (
				--print "found match -> turn edge invisible";
				setEdgeVis getMesh getPolyFace_array[j] k false;
			)
			else (
				--print "found no match -> turn edge visible";
				setEdgeVis getMesh getPolyFace_array[j] k true;
			)
		)
	)
	
	
	--endTime = timeStamp();
	--format "Processing function ( setPolyEdgeVis ) took % seconds\n" ((endTime - startTime) / 1000.0);
	
	
)

-- obsolet -- normalToRotation
/*
function normalToRotation getNa getNg = (
	
	-- converts a 2d normal vector into a rotation value
	-- getNx Ankatete
	-- getNy Gegenkatete
	
	-- get sign
	
	
	--print "----- test -----";
	--print getNg;
	--print getNa;
	--print "--";
	-- calc angle 
	if getNg != 0 and getNa != 0 then (
		my_alpha = atan (getNg as float / getNa as float);
	)
	else (
		if getNg == 0 and getNa != 0 then (
			if getNa > 0 then my_alpha = 0;
			else my_alpha = 180;
		)
		if getNg != 0 and getNa == 0 then (
			if getNg > 0 then my_alpha = 90;
			else my_alpha = -90;
		)
		if getNg == 0 and getNa == 0 then my_alpha = 0;
	)
	
	--print "my_alpha = ";
	--print my_alpha;
	--print "----- test -----";
	return my_alpha;
	
)
*/

function normal2rotation get_vector = (
	
	--print "function: normal2rotation";
		
	-- VECTOR 2 ROTATION

	-- 2. vector on the projection of dummy on the x-y plane
	-- take x and y value == [get_vector.x, get_vector.y, 0]
	
	-- 3. angle between y-vector and the vector from 2.
	z_gamma = (acos(dot (normalize [0, 1, 0]) ( normalize [get_vector.x, get_vector.y, 0]) ) );
	if get_vector.x > 0 then z_gamma *= -1;
	
	-- 4. angle between z-vector and get_vector
	x_gamma = -1 * (acos(dot (normalize [0, 0, 1]) ( normalize [get_vector.x, get_vector.y, get_vector.z]) ) );
	
	return #(z_gamma, x_gamma);
)

-- get Z-Axis vector from objects local coordinate system
function rotation2normal get_object = (
	--ROTATION 2 VECTOR
	--local x = cos ( (this_hardpoint.rotation as eulerangles).z);
	--local y = sin ( (this_hardpoint.rotation as eulerangles).z);
	--local z = sin ( (this_hardpoint.rotation as eulerangles).x);
	return get_object.transform.row3 ;
)

-- wants 3ds max normal vector as point3 and the vector origin as point3
-- returns array #(x, y, z, theDstring)
function makeEawNormal get_Normal get_Origin get_normalExportFormat = (
	
	local _De;
	local _c;
	local _d;
	
	-- normalize to EAW normals
	/*
	get_Normal.x = floor(get_Normal.x * 16384);
	get_Normal.y = floor(get_Normal.y * 16384);
	get_Normal.z = floor(get_Normal.z * 16384);
	*/
	get_Normal.x = get_Normal.x * 16384;
	get_Normal.y = get_Normal.y * 16384;
	get_Normal.z = get_Normal.z * 16384;
	
	_De = -1 * (get_Normal.x*get_Origin.x + get_Normal.y*get_Origin.y + get_Normal.z*get_Origin.z) as integer;
	
	
	-- this is just for backward compatibility to the _d and _c values the 3dz to txt converter gives (v1.8a) the _De values are used within v1.5
	local wasNegative = false;
	local aSign = 1;
	
	if _De == 0 then (
		_c = 0;
		_d = 0;
	)
	else if _De < 0 then (
		wasNegative = true;
		aSign = -1;
		_De *= -1;
	)
	else if _De > 0 then (
		-- nothing special
	)
	
	
	if _De != 0 then (
		-- (_De is here always positiv)
		_cd = bit.intAsHex _De;
		if _cd.count < 4 then (
			_d = _cd;
			_c = "0";
		)
		else (
			_d = substring _cd (_cd.count - 3) -1; -- last 4 digits
			_c = substring _cd 1 (_cd.count - 4); -- everthing before
			if _c == "" then _c = "0";
		)
		
		
		if (bit.hexAsInt _d) > 32769 then ( -- im guessing here.. the half of hex(ffff) is hex(8000-1) -> hex(8000) does not seem to trigger this couse so i try hex(8000+1) -> dezi(32769)
			_d = 65535 - ( bit.hexAsInt (_d) - 1 );
			_d = -1 * aSign * _d;
		)
		else (
			_d = aSign * (bit.hexAsInt _d);
		)
		
		if aSign == 1 then _c = (bit.hexAsInt _c);
		if aSign == -1 then _c = ((bit.hexAsInt _c) + 1) * aSign;
		
		
	)
	
	
	if wasNegative then (
		_De *= -1;
		
		-- _d *= -1;
		-- _c *= -1;
	)
	
	local theDstring;
	if get_normalExportFormat == 1 then (
		theDstring = _d as string + "      " +  _c as string;
	)
	else (
	if get_normalExportFormat == 2 then (
		theDstring = _De as string;
	)
	else (
		print "Error - Normals Mode can't be set, falling back to _d _c";
		theDstring = _d as string + "      " +  _c as string;
	)
	)
	
	return #(get_Normal.x as integer, get_Normal.y as integer, get_Normal.z as integer, theDstring );
	
)



-- returns an array where all faces-per-poly are saved
-- like: myObjectsPolys[Poly3ID] -> #(face12ID, face18ID, face22ID)
-- FC :: setPolyEdgeVis
function getPolyArray get_Mesh = (
	
	--startTime = timeStamp();
	
	thisPoly_array = #();
	thisPolyBit_array = #();
	
	-- create poly_array and thisPolyBit_array
	-- format "mesh faces count = % \n" (getNumFaces exportMesh);
	-- format "mesh edge count = % \n" exportMesh.Edges.count;
	-- check all edges
	for j=1 to get_Mesh.Edges.count do (
		-- get bitarray tmpPoly with all polys that use this edge
		tmpPoly = meshop.getPolysUsingEdge get_Mesh #(j) 
		
		-- print "----------create poly_array----------";
		-- format "\n";
		-- print "check if i alrady have this poly ::";
		--print tmpPoly;
		
		tmpFoundMatch = false;
		-- search through bitarray in reversed order
		for k=thisPolyBit_array.count to 1 by -1 do (
			--format "--> comparing :: new= %  <-->  % \n" tmpPoly thisPolyBit_array[k];
			-- if difference of bitarrays is 0 then both bitarrays are the same
			if  (tmpPoly - thisPolyBit_array[k]).isEmpty and (tmpPoly as array).count ==  (thisPolyBit_array[k] as array).count then ( 
				tmpFoundMatch = true; 
				--print "----> found match, => poly already stored ----> EXIT";
				exit;
			)
			else ( -- found a new poly
				-- debug -> if new poly is more-complete then already saved poly new = #{1..7} saved = #{1..5}
				-- important.. to solve max-bug
				--print "poly debug check"
				if  (tmpPoly * thisPolyBit_array[k]).isEmpty then(
					--print "----> poly is still new but i will continue checking.";
				)
				else (
					-- version 1 :: trying to build maximus size polys
					-- store new and more complete poly over old poly
					tmpFoundMatch = true; 
					thisPolyBit_array[k] = tmpPoly;
					thisPoly_array[k] = (tmpPoly as array);
					--print "poly is better then old one ----> EXIT";
					print " !!! WARNING !!! -- found Poly that holds one of the already stored polys but is bigger -> it has more faces.. this could cause errors!!!!"
					exit;
					
				)
			)
		)
		
		if tmpFoundMatch == false then (
			-- print "--> new poly found !!";
			append thisPolyBit_array tmpPoly ;
			append thisPoly_array (tmpPoly as array) ;
			
			-- this function is very complex .. maybe find a better solution
			setPolyEdgeVis get_Mesh (tmpPoly as array);
		)
		--else print "i already have this poly stored";
	)
	--poly_array[eMeshCounter] = thisPoly_array;
	
	--endTime = timeStamp();
	--format "Processing function ( getPolyArray ) took % seconds\n" ((endTime - startTime) / 1000.0);

	return thisPoly_array;
)

-- gets an array like: get_PolysArray[Poly3] -> #(face12, face 18, face 22)
-- returns an array like: myObjectsPolyVerts[Poly4] -> #(vertex3, vertex1, vertex5, vertex7)
function getPolyVertexArray get_Mesh get_PolysArray = (
	
	--startTime = timeStamp();
	
	-- create polyVertex array
	-- for every face of this poly
	thisPolyVerts_array = #();
	
	for j=1 to get_PolysArray.count do (
		thisPolyVerts_array[j] = #();
		
		-- if poly is normal poly
		if classof get_PolysArray[j][1] == integer then (
			--format "-> working on poly :: % \n"  get_PolysArray[j];
			
			for k=1 to get_PolysArray[j].count do(
				--format "---> face localNr.: % globalNr: %\n" k  get_PolysArray[j][k];
				local p3 = getFace get_Mesh get_PolysArray[j][k];
				if p3.x < 1 or p3.y <1 or p3.z < 1 then (
					tmp = "!!! ERROR !!! - found face with less then 3 verts";
					print tmp;
					return tmp;
				)
				else 	local thisFaceVerts = #(p3.x as integer, p3.y as integer, p3.z as integer);
				
				for m=1 to 3 do (
					-- if vertex is not already part of the polyVertex_array -> store it
					if findItem thisPolyVerts_array[j] thisFaceVerts[m] == 0 then (
						append thisPolyVerts_array[j] thisFaceVerts[m];
					)
					--else print "---> vertex already in thisPolyVerts_array";
				)
			)
		)
		-- if poly is a hardpoint
		else thisPolyVerts_array[j]  = #("hardpoint", "fakeVertexID");
	)
	
	--endTime = timeStamp();
	--format "Processing function ( getPolyVertexArray ) took % seconds\n" ((endTime - startTime) / 1000.0);
	
	return thisPolyVerts_array;
	
)

function getPolyVertexCoordinatesArray get_Mesh get_PolyVertsArray = (
	
	--startTime = timeStamp();
	
	my_PolyVertsCoordArray = #();
	for i=1 to get_PolyVertsArray.count do (
		
		my_PolyVertsCoordArray[i] = #();
		--print "get_PolyVertsArray[i][1]";
		--print get_PolyVertsArray[i][1];
		
		-- if poly is a hardpoint
		if get_PolyVertsArray[i][1] == "hardpoint" then (
			my_PolyVertsCoordArray[i][1] = [999999, 999999, 999999];
		)
		-- if poly is normal poly
		else (
			-- for every vertexID
			for k=1 to get_PolyVertsArray[i].count do (
				-- get vertex coordinates as point3 value
				my_PolyVertsCoordArray[i][k] = getVert get_Mesh get_PolyVertsArray[i][k];
			)
		)
	)
	
	--endTime = timeStamp();
	--format "Processing function ( getPolyVertexCoordinatesArray ) took % seconds\n" ((endTime - startTime) / 1000.0);
	
	return my_PolyVertsCoordArray;
)


function getHPinfo get_HP = (
	
	
	local this_HP = get_HP;
	
	
	local tmpA = #();
	local _index = #();
	tmpA = filterstring this_HP.name "_";
	-- tmpA[1] == "Hardpoint"
	-- tmpA[2] == index=<indexid> describes what kind of hardpoint it is (ex. 10 == propeller)
	-- tmpA[3] == max intern number
	
	if tmpA.count < 3 then (
			tmp= "!! ERROR !! found a Hardpoint with wrong Name! You always need the sheme 'Hardpoint_index=<hardpointCode>_<3dsmaxID>, for example: Hardpoint_index=3_01'";
			format "check -> % \n" tmp;
			return tmp;
	)
	
	--format "execute this tring = % \n" ("_" + tmpA[2]);
	execute("_" + tmpA[2]); -- _index
	_index = filterstring tmpA[2] "=";
	
	-- hardpoint_array[i][1] == index=<indexid> describes what kind of hardpoint it is (ex. 10 == propeller) as integer
	-- hardpoint_array[i][2] == position as point3
	-- hardpoint_array[i][3] == normal ( == z-axis-vector of helper object) as point3
	return #(_index[2] as integer, this_HP.pos, (rotation2normal this_HP), (tmpA[3] as integer) );
	
)
















--  support FUNCTIONS RenderSequenze


-- THIS IS NO GOOD IDEAR.. the direction of the normal vector is not clear .. better read normal from face via maxscript
-- gets 3 points as point3 coordinates and calculates the normal
/*
function calcNormal get_point1 get_point2 get_point3 = (
	
	-- create plane normal with the first 3 points
	v1v2 = [get_point1.x - get_point2.x, get_point1.y - get_point2.y, get_point1.z - get_point2.z];
	v1v3 = [get_point1.x - get_point3.x, get_point1.y - get_point3.y, get_point1.z - get_point3.z];
	-- n = v1v2 x v1v3 .
	vN = [v1v2.y * v1v3.z - v1v2.z * v1v3.y, v1v2.z * v1v3.x - v1v2.x * v1v3.z, v1v2.x * v1v3.y - v1v2.y * v1v3.x];
	
	return vN;
)
*/

function absoluteJoin get_array1 get_array2 = (
	
	-- array1 must be the longer array
	if get_array1.count > get_array2.count then (
		array1 = get_array1;
		array2 = get_array2;
	)
	else (
		array1 = get_array2;
		array2 = get_array1;
	)
	
	returnArray = #();
	
	for i=1 to array1.count do (
		
		if array1[i] == undefined and array2[i] == undefined then returnArray[i] = undefined;
		if array1[i] != undefined and array2[i] == undefined then returnArray[i] = array1[i];
		if array1[i] == undefined and array2[i] != undefined then returnArray[i] = array2[i];
		if array1[i] != undefined and array2[i] != undefined then returnArray[i] = "Error, can't join array here bc of two values :: " + array1[i] as string + array2[i] as string ;
	)
	
	return returnArray;
)



-- check if point get_point is above or below face A specified by get_pointOnPlaneCoord and get_normal
-- returns -1 == below, 0 == on plane, 1 == above
function RS_pointRelPositionCheck get_pointCoord get_pointOnPlaneCoord get_normal = (
	
	-- THIS IS ONE OF THE MOST IMPORTANT FUNCTION FOR RS
	-- if this function does not work properly, all others will calculate wrong values
	
	-- normal vektor of the face/poly == get_normal
	-- vector of one point of the face/poly to the get_point -> vector P
	-- "spitze minus fu"
	vNew = [get_pointCoord.x - get_pointOnPlaneCoord.x, get_pointCoord.y - get_pointOnPlaneCoord.y, get_pointCoord.z - get_pointOnPlaneCoord.z];
	vNewLength = length vNew;
	--format "VNewLength = % \n" vNewLength;
	
	if vNewLength < 0.001 then (
		--print "is 0 (length exeption)";
		return 0;
	)
	
	
	-- for more precision the value is going to be multiplicated by 1000
	debug_offset = 100;
	-- angle between normal vektor and vector P -> vGamma
	vGamma = (acos ( dot (normalize get_normal) (normalize vNew) ) * debug_offset) as integer;
	-- if vGamma < 90 then point get_pointCoord is above the face/poly .... if vGamma > 90 then point is below ... if vGamma == 90 then point is on the same plane
	--format "vGamma * % :=: % \n" debug_offset vGamma ;
	
	local onPlaneValue = 90 * debug_offset; -- if vGamma is 90 the point is on the sameLevel as the plane
	local debug_round = 10; -- sometimes there are anglesValues like 8999 (above) but they should be 9001 (below) but in fact they should be 9000 (on plane) 
	if vGamma < onPlaneValue + debug_round and  vGamma > onPlaneValue - debug_round then (
		--print "is 0";
		return 0;
	)
	if vGamma < onPlaneValue then ( 
		--print "is 1";
		return 1;
	)
	if vGamma > onPlaneValue then ( 
		--print "is -1";
		return -1; 
	)
	else ( 
		--print "ERROR";
		return 0; 
	)
	
)

-- check if all points in the array get_pointsID are coplanar
-- returns true or false
-- FC :: RS_pointRelPositionCheck
function RS_check_coplanar get_pointsCoord = (
	
	-- THIS IS STUPID.. the directon of the normal is not clear, better get normal from face per maxscript -- ok here it is unimportant bc we look for points who are above OR below.. so the direction of the normal does not matter
	-- create plane normal with the first 3 points
	v1v2 = [get_pointsCoord[1].x - get_pointsCoord[2].x, get_pointsCoord[1].y - get_pointsCoord[2].y, get_pointsCoord[1].z - get_pointsCoord[2].z];
	v1v3 = [get_pointsCoord[1].x - get_pointsCoord[3].x, get_pointsCoord[1].y - get_pointsCoord[3].y, get_pointsCoord[1].z - get_pointsCoord[3].z];
	-- create Normal based on the last two vectors with this formula :: n = v1v2 x v1v3 .
	vN = [v1v2.y * v1v3.z - v1v2.z * v1v3.y, v1v2.z * v1v3.x - v1v2.x * v1v3.z, v1v2.x * v1v3.y - v1v2.y * v1v3.x];
	
	
	-- check if all other points ar on the same plane (RS_pointRelPositionCheck == 0)
	for i=4 to get_pointsCoord.count do (
		if (RS_pointRelPositionCheck get_pointsCoord[i] get_pointsCoord[1] vN) != 0 then (
			return false;
		)
	)
	return true;
)

-- gets Mesh
-- checks all Polys for non coplanar ones 
-- NEEDS AN EDITABLE_MESH !!
-- returns bitarray with all faces of non coplanar polys
-- FC :: getPolyVertexArray; getPolyVertexCoordinatesArray; RS_check_coplanar
function RS_check_mesh_coplanar get_Mesh get_PolyArray= (
	
	-- COPLANAR CHECK
		-- get poly to face array
		-- get poly to vertID array 
		-- get poly to vert Coordinates array
		-- for every poly: 	check if poly is not coplanar and save not coplanar poly in bit-array (faces)
		-- return bit-array
	--print "get PolyArray";
	my_PolyArray = #(); -- stores the facesID's of every poly
	--my_PolyArray = getPolyArray get_Mesh;
	my_PolyArray = get_PolyArray;
	--print "get PolyVertsArray";
	my_PolyVertsArray = #(); -- stores the vertID's for every poly
	my_PolyVertsArray = getPolyVertexArray get_Mesh my_PolyArray;
	--print "get PolyVertsCoordArray";
	my_PolyVertsCoordArray = getPolyVertexCoordinatesArray get_Mesh my_PolyVertsArray; -- stores the vertCoordinates for every poly
	
	--print "Part B";
	--print "my_PolyVertsCoordArray :: ";
	--print my_PolyVertsCoordArray;
	
	nonCoplanarPolys = #{}; -- bitarray with all facesID's that are part of non coplanar polys
	-- for every poly:
	for i=1 to my_PolyArray.count do (
		-- check if poly is not coplanar and save not coplanar poly in bit-array (faces)
		if (RS_check_coplanar my_PolyVertsCoordArray[i]) == false then (
			nonCoplanarPolys = nonCoplanarPolys + (my_PolyArray[i] as bitarray);
			format "poly % is NON coplanar \n" my_PolyArray[i];
		)
		--else format "poly % is ok \n" my_PolyArray[i];
	)
	
	return nonCoplanarPolys;
)

-- get get_positionP3  -- looks like [above count, same level count, below count]
-- get get_relPosValue -- looks like this -1, or 0 or 1 (below , same level, above)
function RS_makePositionP3 get_positionP3 get_relPosValue = (
	
	if get_positionP3 == undefined then my_positionP3= [0,0,0];
	else 	my_positionP3 = get_positionP3 as point3;
	
	my_relPosValue = get_relPosValue ;
	
	
	if my_relPosValue == 1 then (my_positionP3.x += 1;) -- above
	else (
		if my_relPosValue == 0 then (my_positionP3.y += 1;) -- same level
		else (
			if my_relPosValue == -1 then (my_positionP3.z += 1;) -- below
			else format "!!! WARNING !!! wrong position value % --- only values like -1(== below), 0(== same level) or 1(==above) are allowed \n" my_relPosValue;
		)
	)
	return my_positionP3;
)


-- gets bitarray get_PolySelection -> #{1..4, 6, 7..10}
-- gets array get_PolyVertsCoordArray -> #( #([v1.x, v1.y, v1.z], [v2.x, v2.y, v2.z], [v3.x, v3.y, v3.z]) , #(...allVertCoordsOfPoly2..), #(...allVertCoordsOfPoly3..) , ...)
-- returns polyPositionArray -- it looks like 
-- #( #([-1,-1,-1], [0,0,5], [0,2,3], [0,2,3]), #([0,0,5], [-1,-1,-1], [0,2,3], [0,2,3]), #(...) ... )
-- every point3 value is coded like this  [points above count, points same level count, points below count]
-- FC :: getPolyVertexArray; getPolyVertexCoordinatesArray; RS_pointRelPositionCheck; RS_makePositionP3
function RS_polyPositionCalc get_Mesh get_Hardpoints get_PolySelection get_PolyArray = (
	
	-- for every poly(selection)
		-- check all other polys(selection) if their center is above or below this_polys
		-- check if their vertices are above or below
		-- multiplicate a weight ( vert above == 1 , vert below == -1 , center above == 1*weight center below == -1*weight)
		-- combine ( Sum verts + center)
		-- save in array:  this_face -> face_n is absolute above(4) / absolute below(-4) / inbetween (3 to -3) / the same plane with same -or- different normal
		-- save in new array the two faces that are absolute above and absolute below and are as close as possible to this_face
	
	
	
	
	my_PolyArray = #(); -- stores the facesID's of every poly
	--my_PolyArray = getPolyArray get_Mesh;
	my_PolyArray = get_PolyArray;
	my_PolyVertsArray = #(); -- stores the vertID's for every poly
	
	my_PolyVertsArray = getPolyVertexArray get_Mesh my_PolyArray;
	print "my_PolyVertsArray";
	print my_PolyVertsArray;
	my_PolyVertsCoordArray = getPolyVertexCoordinatesArray get_Mesh my_PolyVertsArray; -- stores the vertCoordinates for every poly
	print "my_PolyVertsCoordArray";
	print my_PolyVertsCoordArray;
	
	my_Hardpoints = get_Hardpoints;
	
	
	
	-- convert selection into array
	my_PolySelection = get_PolySelection as array;
	
	-- this array stores for (every or this ?) poly which polys are above/below/sameLevel exept for itself (good or not?)
	-- polyPositionArray[PolyID] -> [PolyID1, positionvalue1] , [PolyID2, positionvalue2], [PolyID3, positionvalue3] ...
	-- !!! IMPORTANT:: 
		-- if positionvalue == poly vertCount + 1 (center) then	poly is absolute above of POI
		-- if positionvalue == -1 * (poly vertCount + 1 (center)) then poly is absolute below of POI
		-- if positionvalue == 0 _AND_ the normal is the same as the POI-normal , then poly is absolute on sameLevel as POI
		-- everthing between is poly that is partly above and below (or above/below and sameLevel)
	polyPositionArray = #();
	
	
	
	-- for every poly(selection)
	-- this poly is called PolyOfInterest POI
	for i=1 to my_PolySelection.count do (
		
		/*
		print "+++++ POLY ++++++++++++++++++++++++++++++++";
		print i;
		print "+++++++++++++++";
		*/
		
		-- the Poly Of Interest _ poly-ID
		POI_ID = my_PolySelection[i];
		
		-- HARDPOINT INJECTION
		-- check if poly is a hardpoint ( == fake poly)
		
		--format "first face ID == % \n" my_PolyArray[POI_ID][1];
		if classof my_PolyArray[POI_ID][1] == String then (
			if (findString my_PolyArray[POI_ID][1] "hp") == 1 then (
				-- poly is a hardpoint
				--print "is hardpoint";
				local hardpointID = (replace my_PolyArray[POI_ID][1] 1 2 "") as integer;
				--print "hardpointID";
				--print hardpointID;
				POI_pointCoord = my_Hardpoints[hardpointID][2];
				POI_normal = normalize my_Hardpoints[hardpointID][3];
			)
			else format "!!! Error !!! - wrong hardpoint pointer = % \n" my_PolyArray[POI_ID][1];
		)
		else (
			-- poly is normal poly
			--print "is normal poly"
			-- choose ONE vertex of this poly -- we choose the first one
			POI_pointCoord = my_PolyVertsCoordArray[POI_ID][1];
			-- get the normal of the first face of the POI (it is the same for all other faces of this POI)
			POI_normal = getFaceNormal get_Mesh my_PolyArray[POI_ID][1];
		)
		
		polyPositionArray[i] = #();
		
		
		-- check all other polys(selection) if their center is above or below this_polys
		-- and check if their vertices are above or below
		for k=1 to my_PolySelection.count do (
			local positionValue = undefined;
			local thisPolyCenterPos = undefined;
			local thisPolyCenterCoord = undefined;
			-- do not use the poly we are using as root at the moment
			--print "####################";
			--print k;
			if i != k then (
				
				
				-- check if Hardpoint
				if my_PolyVertsCoordArray[k][1].x == 999999 and my_PolyVertsCoordArray[k][1].y == 999999 and my_PolyVertsCoordArray[k][1].z == 999999 then (
					
					local thisHardpointID = (replace my_PolyArray[k][1] 1 2 "") as integer;
					--print "this poly is a hardpoint - ID = ";
					--print thisHardpointID;
					
					
					local HPpos = my_Hardpoints[thisHardpointID][2];
					--print "this hardpoint pos = "
					--print HPpos;
					
					thisHardpointPos = RS_pointRelPositionCheck HPpos POI_pointCoord POI_normal;
					positionValue = RS_makePositionP3 positionValue thisHardpointPos;
				)
				else (
					-- ## check Center
					
					-- calculate arithmetic mean of all vert coordinates
					local tmp = [0,0,0];
					for j=1 to my_PolyVertsCoordArray[k].count do (
						tmp.x += my_PolyVertsCoordArray[k][j].x;
						tmp.y += my_PolyVertsCoordArray[k][j].y;
						tmp.z += my_PolyVertsCoordArray[k][j].z;
						
					)
					tmp.x = tmp.x / my_PolyVertsCoordArray[k].count;
					tmp.y = tmp.y / my_PolyVertsCoordArray[k].count;
					tmp.z = tmp.z / my_PolyVertsCoordArray[k].count;
					
					-- center of the poly we want to know if it is above/below/sameLevel as the POI
					thisPolyCenterCoord = tmp;
					
					-- check if poly center is above/below/sameLevel as the POI
					thisPolyCenterPos = RS_pointRelPositionCheck thisPolyCenterCoord POI_pointCoord POI_normal;
					positionValue = RS_makePositionP3 positionValue thisPolyCenterPos;
					--format "thisPolyCenterPos = % \n" thisPolyCenterPos;
					
					
					-- ## and now check Vertices
					
					-- check for every vert of thispoly if it is above/below/sameLevel as the POI
					local tmp = 0;
					for j=1 to my_PolyVertsCoordArray[k].count do (
						--print j
						tmp =  RS_pointRelPositionCheck my_PolyVertsCoordArray[k][j] POI_pointCoord POI_normal;
						positionValue = RS_makePositionP3 positionValue tmp;
						--format "---vertex postion = % \n" tmp;
					)
				)
				
				polyPositionArray[POI_ID][k] = positionValue;
			)
			-- mark the position of the POI with an Sign in the position array
			else polyPositionArray[POI_ID][k] = [-1,-1,-1];
		)
	)
	
	--print " :: polyPositionArray";
	--print polyPositionArray;
	return polyPositionArray;
	
)



-- create my_PolyPositionsSimple array
-- format my_PolyPositionsSimple[PolyID] ->  #(Poly1code, Poly2code, Poly3code, ...)
-- codes: 1 == above, 0 == sameLevel, -1 == below, 666 == inbetween, 100 == thisPoly
function RS_polyPositionSimpleCalc get_PolyPositions = (
	
	my_PolyPositionsSimple = #();
	
	my_PolyPositions = get_PolyPositions;
	
	
	for i=1 to my_PolyPositions.count do ( -- for every poly
		
		my_PolyPositionsSimple[i] = #();
		for k=1 to my_PolyPositions[i].count do ( -- for every position point3 value :: [above count, sameLevel count, below count]
			local p3 = my_PolyPositions[i][k];
			
			-- the poly itself
			if p3.x == -1 and p3.y == -1 and p3.z == -1 then (
				my_PolyPositionsSimple[i][k] = 100;
			)
			else (
				-- poly is sameLevel
				if p3.x == 0 and p3.z == 0 then (
					my_PolyPositionsSimple[i][k] = 0;
				)
				else (
					-- poly is ABSOLUTE above
					if p3.x != 0 and p3.z == 0 then (
						my_PolyPositionsSimple[i][k] = 1;
					)
					else (
						-- poly is ABSOLUTE below
						if p3.x == 0 and p3.z != 0 then (
							my_PolyPositionsSimple[i][k] = -1;
						)
						-- poly is inbetween (below and above)
						else my_PolyPositionsSimple[i][k] = 666;
					)
				)
			)
		)
	)
	--print " :: my_PolyPositionsSimple";
	--print my_PolyPositionsSimple;
	
	
	return my_PolyPositionsSimple;
	
)

-- create an array where the absolute above and absolute below polys are counted 
-- format allPolyPos[PolyID] = [polys above count ,  polys sameLevel count, polys below count, polys inbetween count]
function RS_allPolyPosCalc get_PolyPositionsSimple = (
	
	my_PolyPositionsSimple = get_PolyPositionsSimple;
	
	my_allPolyPos = #();
	for i=1 to my_PolyPositionsSimple.count do (
		my_allPolyPos[i] = [0,0,0,0];
		for k=1 to my_PolyPositionsSimple[i].count do (
			
			local code = my_PolyPositionsSimple[i][k];
			-- poly is sameLevel
			if code == 0 then my_allPolyPos[i].y += 1;
			-- poly is above
			if code == 1 then my_allPolyPos[i].x += 1;
			-- poly is below
			if code == -1 then my_allPolyPos[i].z += 1;
			-- poly is inbetween
			if code == 666 then my_allPolyPos[i].w += 1;
			-- poly is not selected 
			if code == 222 then () -- do nothing
		)
		
	)
	--print " :: my_allPolyPos";
	--print my_allPolyPos;
	
	return my_allPolyPos;
	
	
)


function RS_HPtoFakePoly get_Hardpoints = (
	
	local my_Hardpoints = get_Hardpoints;
	local fakePolyArray = #();
	
	for i=1 to my_Hardpoints.count do (
		
		append fakePolyArray #("hp" + i as string);
	)
	
	return fakePolyArray;
)







-- ###################################################################
--  RENDER SEQUENCE main FUNCTIONs

-- RECURSIVE !!!
-- as less calculation as possible in here .. use get_ vars !!!
-- gets PolySelection .. an bitarray with the ID's of the polys to work on
-- get_PolyPositionsSimple[PolyID] ->  #(Poly1code, Poly2code, Poly3code, ...)
-- for Debuggin help only
-- get PolyArray .. an array with all polys :: myObjectsPolys[Poly3ID] -> #(face12ID, face18ID, face22ID)
-- get_Mesh
-- FC :: ...
function RS_treeCalc get_PolySelection get_PolyPositionsSimple get_PolyArray get_Mesh get_Hardpoints get_mainAxis= (
	
	--print "------------- START RS_treeCalc function ------------- ";
	
	my_PolyArray = get_PolyArray;
	my_Mesh = get_Mesh;
	my_Hardpoints = get_Hardpoints;
	my_mainAxis = get_mainAxis;
	--format "my_mainAxis = % \n" my_mainAxis;
	
	
	-- convert bitarray to normal array
	-- if this_PolySelection.count == 0 then this is an dead end .. just return 255
	this_PolySelection = get_PolySelection as array;
	--format "this_PolySelection = % \n" this_PolySelection;
	--print this_PolySelection;
	
	
	if this_PolySelection.count == 0 then (
		--print "dead end, == 255 => ------------- END RS_treeCalc function ------------- ";
		return #("255", #());
	)
	
	
	
	
	
	
	
	-- +++++++++++++++++++++++++++++++++++++++++
	-- shrink  PolyPositionsSimple to get_PolySelection
	this_PolyPositionsSimple = get_PolyPositionsSimple;
	reduced_PolyPositionsSimple = #();
	
	--print "get_PolyPositionsSimple";
	--print this_PolyPositionsSimple;
	
	
	for i=1 to this_PolyPositionsSimple.count do ( -- for every poly
		
		reduced_PolyPositionsSimple[i] = #();
		
		-- is this poly part of the selection?
		local thisPoly;
		if (findItem this_PolySelection i) != 0 then thisPoly = i;
		else thisPoly = undefined;
		
		
		-- take only the selected ones and check ...
		if thisPoly != undefined then ( 
			
			tmpK = #();
			for k=1 to this_PolyPositionsSimple[i].count do ( -- every relative poly
				
				-- is this sub poly part of the selecton?
				local thisSubPoly;
				if (findItem this_PolySelection k) != 0 then 	thisSubPoly = k;
				else thisSubPoly = undefined;
				
				if thisSubPoly != undefined then (
					reduced_PolyPositionsSimple[i][k] = this_PolyPositionsSimple[i][k];
				)
				-- poly is NOT selected
				else reduced_PolyPositionsSimple[i][k] = 222;
			)
		)
		-- poly is NOT selected
		else (
			for k=1 to this_PolyPositionsSimple[i].count do ( -- every relative poly
				reduced_PolyPositionsSimple[i][k] = 222;
			)
		)
		
		
	)
	this_PolyPositionsSimple = reduced_PolyPositionsSimple;
	--print "reduced_PolyPositionsSimple";
	--print this_PolyPositionsSimple;
	-- +++++++++++++++++++++++++++++++++++++++++
	-- +++++++++++++++++++++++++++++++++++++++++
	-- get_allPolyPos[PolyID] = [polys above count ,  polys sameLevel count, polys below count, polys inbetween count]
	this_allPolyPos = RS_allPolyPosCalc this_PolyPositionsSimple;
	--print "this_allPolyPos";
	--print this_allPolyPos;
	-- +++++++++++++++++++++++++++++++++++++++++
	
	
	
	
	
	
	
	-- +++++++++++++++++++++++++++++++++++++++++
	-- FIND THE CUT-POLY
	-- also important: if possible prefere a cutPoly that is aligned to the mainAxis (settings value from UI rollout)
	-- for every poly in the selection do...
	
	bestBalance = 9999; -- start value.. best value would be 1
	bestBalance_AlignedPoly = 9999; -- start value.. best value would be 1
	this_cutPoly; -- ID of the cut poly of this function run
	foundMainAxisPolyCount = 0; -- count all polys that are aligned to the main axis
	
	
	for i=1 to this_PolySelection.count do (
		
		
		
		
		this_PolyID = this_PolySelection[i];
		--format "PolyID == % \n" this_PolyID;
		
		
		thisIsHardpoint = false;
		-- check if this is a hardpoint
		if classof my_PolyArray[this_PolyID][1] == string then (
			local hardpointID = (replace my_PolyArray[this_PolyID][1] 1 2 "") as integer;
			this_PolyNormal = my_Hardpoints[hardpointID][3];
			thisIsHardpoint = true;
		)
		-- is normal poly
		else this_PolyNormal = getFaceNormal my_Mesh my_PolyArray[this_PolyID][1];
		
		-- make sure normal is only positive
		this_PolyNormal.x = (this_PolyNormal.x^2)^0.5;
		this_PolyNormal.y = (this_PolyNormal.y^2)^0.5;
		this_PolyNormal.z = (this_PolyNormal.z^2)^0.5;
		
		--format "PolyNormal = % \n" this_PolyNormal;
		
		
		
		
		local thisPolyAligned = false;
		local thisPolybetterBalance = false;
		
		-- cutPoly does not have any INBETWEEN POLYS
		-- take the first one you can find and check balance value
		if this_allPolyPos[this_PolyID].w == 0 then (
			--print "poly does not have any inbetween polys";
			
			-- check if poly is aligned to main axis
			if (normalize this_PolyNormal) == my_mainAxis then (
				--print "poly is aligned to mainAxis";
				foundMainAxisPolyCount += 1;
				thisPolyAligned = true;
			)
			--else print "poly is not aligned to mainAxis";
			
			
			
			-- check how even the above and below count is (a balance value of 1 is best)
			local balance;
			balance = (this_allPolyPos[this_PolyID].x+0.01) / (this_allPolyPos[this_PolyID].z+0.01); 
			--print this_allPolyPos[this_PolyID].x;
			--print this_allPolyPos[this_PolyID].z;
			--format "new balance is = % , bestBalance is = % \n" balance bestBalance;
			
			-- if best BALANCE till now then
			if thisPolyAligned then (
				if (1-balance)^2 <  (1-bestBalance_AlignedPoly)^2 then (
					--print "poly has better balance value then any other _Aligned Poly_ till now";
					bestBalance_AlignedPoly = balance;
					thisPolybetterBalance = true;
				)
				--else print "old _Aligned Poly_ balance is closer to 1 and therefore better";
			)
			else (
				if (1-balance)^2 <  (1-bestBalance)^2 then (
					--print "poly has better balance value then any other till now";
					bestBalance = balance;
					thisPolybetterBalance = true;
				)
				--else print "old balance is closer to 1 and therefore better";
			)
			
			
			-- based on the balance values , choose if this poly is the new CUT POLY or not
			if thisIsHardpoint then (this_cutPoly = this_PolyID;) -- is hardpoint
			else ( -- no hardpoint
				if thisPolyAligned then (
					if foundMainAxisPolyCount > 1 then (
						if thisPolybetterBalance then (
							--print "found new cutPoly -- another poly aligned to mainAxis with better balance value";
							this_cutPoly = this_PolyID;
						)
					)
					else (
						--print "found new cutPoly -- first poly aligned to mainAxis";
						this_cutPoly = this_PolyID;
					)
				)
				else (
					if thisPolybetterBalance then (
						--print "found new cutPoly -- another poly (not aligned to mainAxis) with better balance value";
						this_cutPoly = this_PolyID;
					)
				)
			)
			
		)
		--else print "poly has inbetween polys";
		
		
	) -- end for
	
	
	if this_cutPoly == undefined then (
		format "!!! ERROR !!! found an RS-Loop :: % \n" this_PolySelection;
		print "CHECK YOUR FACE SELECTION";
		--print "------------- END RS_treeCalc function ------------- ";
		
		-- select all faces which do cause the loop
		this_FaceSelection = #();
		for i=1 to this_PolySelection.count do (
			local faceIDs = my_PolyArray[this_PolySelection[i]]
			
			if classof faceIDs[1] == string then (
				format "hardpoint % is part of an RS Loop \n" faceIDs[1]
			)
			else (	
				join this_FaceSelection faceIDs;
			)
			
		)
		-- NOTE: only the LAST rs-loop found will be selected
		-- deselect all first;
		my_Mesh.selectedfaces = #{};
		
		my_Mesh.selectedfaces = this_FaceSelection as bitarray
		--print "this_FaceSelection :: ";
		--print this_FaceSelection;
		
		
		return #("ERROR - RS-LOOP", #());
	)
	
	--format "this_cutPoly == % \n" this_cutPoly;
	-- +++++++++++++++++++++++++++++++++++++++++
	
	
	
	
	
	-- +++++++++++++++++++++++++++++++++++++++++
	-- create two arrays with all polys that are cut by the cutPoly into abovePolys and belowPolys
	-- bit arrays with polys above and below the cut poly
	abovePolyArray = #{};
	belowPolyArray = #{}; 
	
	singleRelPolyPosArray = this_PolyPositionsSimple[this_cutPoly];
	for i=1 to singleRelPolyPosArray.count do (
	-- i == PolyID
		
		-- is this poly part of the selection?
		local thisPoly;
		if (findItem this_PolySelection i) != 0 then thisPoly = i;
		else thisPoly = undefined;
		
		
		if thisPoly != undefined then ( -- only for selected polys !!!
		
			if singleRelPolyPosArray[i] == 100 then () -- do nothing.. it's the cutpoly itself
			if singleRelPolyPosArray[i] == 666 then (print "!!! ERROR !!! here shouldn't be any inbetween polys..";) -- the cut poly may not have any inbetween polys.. so this is just an test to reveal problems if there are any
			if singleRelPolyPosArray[i] == 1 then ( -- above
				append abovePolyArray i;
			)
			if singleRelPolyPosArray[i] == 0 then ( -- sameLevel
				-- sameLevel polys can be put in any of the two arrays.. but maybe there is a way to find the best fitting place?!
				append abovePolyArray i; -- just for now i put them in here
				--append belowPolyArray i;
			)
			if singleRelPolyPosArray[i] == -1 then ( -- below
				append belowPolyArray i;
			)
		)
		--else format "x poly % not in selection \n" i;
	)
	--print "ABOVE array";
	--print abovePolyArray;
	--print "BELOW array";
	--print belowPolyArray;
	-- +++++++++++++++++++++++++++++++++++++++++
	
	
	
	
	
	--print "------------------------------";
	
	-- RECURSIVE function call in HERE
	
	-- aboveTree = "drber";
	--#(this_cutPoly , this_rsTree);
	aboveTree = RS_treeCalc abovePolyArray this_PolyPositionsSimple my_PolyArray my_Mesh my_Hardpoints my_mainAxis;
	
	-- belowTree = "drunter";
	-- #(this_cutPoly , this_rsTree);
	belowTree = RS_treeCalc belowPolyArray this_PolyPositionsSimple my_PolyArray my_Mesh my_Hardpoints my_mainAxis;
	
	this_rsTree = #();
	
	--print "aboveTree[2]";
	--print aboveTree[2];
	
	--print "belowTree[2]";
	--print belowTree[2];
	--print "-";
	
	-- if cut poly == 255 then this is a dead end
	if aboveTree[1] != "255" then (
		this_rsTree = absoluteJoin this_rsTree aboveTree[2];
	)
	if belowTree[1] != "255" then (
		this_rsTree = absoluteJoin this_rsTree belowTree[2];
	)
		
	
	-- ;S000= ;S000= drawLast drawFirst
	-- ;S000=  above below
	this_rsTree[this_cutPoly] = aboveTree[1] as string  + "       " + belowTree[1] as string ;
	--format "this_rsTree[%] = " this_cutPoly;
	--print this_rsTree[this_cutPoly];
	
	--print "------------- END RS_treeCalc function";
	
	-- +++++++++++++++++++++++++++++++++++++++++
	-- this is only needed bc EAW starts to count with 0 and max with 1
	this_cutPoly -= 1;
	-- +++++++++++++++++++++++++++++++++++++++++
	return #(this_cutPoly , this_rsTree);
	
	
	
	
)




-- test RS_tree
-- FC :: ...
function RS_makeRS get_Mesh get_Hardpoints get_Options= (
	
	startTime = timeStamp();
	
	format " \n \n \n ###++++++++++++++### START OF FUNCTION RS_makeRS ###++++++++++++++### \n";
	
	-- Editable_Mesh
	myMesh = get_Mesh;
	
	-- hardpoint_array[i][1] == index=<indexid> describes what kind of hardpoint it is (ex. 10 == propeller) as integer
	-- hardpoint_array[i][2] == position as point3
	-- hardpoint_array[i][3] == normal ( == z-axis-vector of helper object) as point3
	myHardpoints = get_Hardpoints;
	--print "myHardpoints";
	--print myHardpoints;
	
	-- nomalized point3 value
	mainAxis = get_Options[1];
	format "main Cut Plane is : % \n" mainAxis;
	
	
	
	
	if myMesh.modifiers.count > 0 then (
		print ("better remove all modifiers from this object ::" + myMesh as string );
		print ("----- this _can_ solve occurring problems");
	)
	
	
	
	
	
	-- check if editable_Mesh (it's better to allow only editable_Mesh bc editPoly does not allow strange geo like it is used by bulkhead elements
	
	-- FUNCTION :: RS_check_mesh_coplanar
		-- COPLANAR CHECK
		-- create face to poly array (need function)
		-- for every poly: 	get verts of poly (need function)
		-- 						check if poly is not coplanar and save not coplanar poly in bit-array (faces)
		-- after complete run through all polys check if there where any non coplanar polys
		-- 		IF YES: stop calculation post error message and select not coplanar polys per bit-array
	
	
	-- FUNCTION :: RS_polyPositionCalc
		-- for every poly
		-- check all other polys if their center is above or below this_polys
		-- check if their vertices are above or below
		-- multiplicate a weight ( vert above == 1 , vert below == -1 , center above == 1*weight center below == -1*weight)
		-- combine ( Sum verts + center)
		-- save in array:  this_face -> face_n is absolute above(4) / absolute below(-4) / inbetween (3 to -3) / the same plane with same -or- different normal
		-- save in new array the two faces that are absolute above and absolute below and are as close as possible to this_face
	
		-- many faces with an inbetween value can cause the rs_calc to crash _ if the corresponding face is close to this_face
		-- if a face is on the same plane as this_face with the same normal the rs_order is unimportant (true ?!)
	
	
	-- IDEA 1
	-- FUNKTION :: RS_treeCalc: 
		
		-- search the poly that has ONLY absolute above _AND_ absolute below polys 
			-- and is closest (position sameLevel as axis and normal the same) to a central axis.. this helps to force the start element to be aligned to one specific model-mirror axis
		-- if there is no such poly stop and post error
		-- result: two arrays with polys above and polys below (polys who are on the same plane can be on either side (true?!) )
		-- start for every of the two arrays the same function RS_treeCalc
		-- save the result of every functon RS_treeCalc so we know which poly of all poly above/below has the most poly above and below (this poly)
			-- important: remeber polys which face in the other direction as the starting-poly have to be turned in the rs-tree (read into this stuff again)
	
		-- IMPORTANT :: once there is no poly left with only absolute above and below polys the rs-tree is un-calculateable
		 -- possible Solution: start again from the beginning and choose other slice-polys (good idea)?
	
	
	
	-- ABOUT HARDPOINTS
		-- IMPORTANT: hardpoints can't cause, or be part of, an RS_Loop.. !!
		-- it is important to create a hardpoint array first (like when exporting the model)
		-- inject fakepoly functionality into RS_polyPositionCalc, if hardpoint is found dont use getFaceNormal function but read the normal value and postion out of the hardpoint array
		-- inject fakepoly functionality into getPolyVerts and getPolyVertsCoord functions
		
		-- convert hardpoint into an fake poly (important: the rendersequenzID must be the same compared to the elementID _after export_)
			-- build up by 3 fake verts whose positions == hardpoint position
			-- get normal from hardpoint array
			
		-- add hardpoints to polyArray
		
		-- while calculatin the RS the script must check if the poly is an hardpoint (hardpoints are strings like "hp3" unlike real polys/faces which are integers)
		
	
	
	
	
	-- check if editable_Mesh (it's better to allow only editable_Mesh bc editPoly does not allow strange geo like it is used by bulkhead elements
	if classof myMesh != Editable_mesh then (
		format "!!! ERROR !!! - please select an Editable_Mesh, this selection is :: % \n" myMesh;
	)
	else (
		
		-- ++++++++++++++++++++++++++++++++++++++++
		my_PolyArray = #(); -- stores the facesID's of every poly
		my_PolyArray = getPolyArray get_Mesh;
		--print " :: my_PolyArray";
		--print my_PolyArray;
		-- ++++++++++++++++++++++++++++++++++++++++
		
		
		-- ++++++++++++++++++++++++++++++++++++++++
		-- COPLANAR CHECK
			-- 	if there are any non coplanar polys: post warning  and select not coplanar polys per bit-array
		badPolyFaces = RS_check_mesh_coplanar myMesh my_PolyArray;
		if badPolyFaces.count > 0 then (
			myMesh.selectedfaces = badPolyFaces;
			print "!!! WARNING !!! - found non coplanar poly(element), check your face-selection to see which!";
		)
		else print "all polys are coplanar, that's a good thing!";
		-- ++++++++++++++++++++++++++++++++++++++++
	
		
		
		
		

		
		
		
		
		
		--print " get Vars";
		
		
		
		
		-- inject fake hardpoint-polys
		my_PolyAndHardpointsArray = my_PolyArray + (RS_HPtoFakePoly myHardpoints);
		--print "my_PolyAndHardpointsArray";
		--print my_PolyAndHardpointsArray;
		
				
		
		
		-- ++++++++++++++++++++++++++++++++++++++++
		my_PolyPositions = #(); -- stores for every poly the relative position of all other polys based on their vertices & center  [points above count, points same level count, points below count]
		my_PolyPositions = RS_polyPositionCalc get_Mesh myHardpoints #{1..(my_PolyAndHardpointsArray.count)} my_PolyAndHardpointsArray;
		--print " :: my_PolyPositions";
		--print my_PolyPositions;
		-- ++++++++++++++++++++++++++++++++++++++++
		
		

			-- ++++++++++++++++++++++++++++++++++++++++
			my_PolyPositionsSimple = #(); 	-- stores for every poly the relative postion of all other polys format my_PolyPositionsSimple[PolyID] ->  #(Poly1code, Poly2code, Poly3code, ...)
														-- codes: 1 == above, 0 == sameLevel, -1 == below, 666 == inbetween, 100 == thisPoly
			my_PolyPositionsSimple = RS_polyPositionSimpleCalc my_PolyPositions;
			--print " :: my_PolyPositionsSimple";
			--print my_PolyPositionsSimple;
			-- ++++++++++++++++++++++++++++++++++++++++
		
		
		
				-- ++++++++++++++++++++++++++++++++++++++++
				my_allPolyPos = #();	-- create an array where the absolute above and absolute below polys are counted 
												-- format allPolyPos[PolyID] = [polys above count ,  polys sameLevel count, polys below count, polys inbetween count]
				my_allPolyPos = RS_allPolyPosCalc my_PolyPositionsSimple;
				--print " :: my_allPolyPos";
				--print my_allPolyPos;
				-- ++++++++++++++++++++++++++++++++++++++++
		
		
		print "starting recursive function (processing function can take up to 2 minutes)\n";
		
		
		-- +++++++++++++++++++++++++++++++++++++++
		-- Recursive function !!
		RS_output = (RS_treeCalc #{1..(my_PolyAndHardpointsArray.count)} my_PolyPositionsSimple my_PolyAndHardpointsArray myMesh myHardpoints mainAxis);
		
		format "startelement is % \n" RS_output[1];
		--print "RS Tree";
		--print ((RS_output[1] as string) + "     " + "0");
		--print RS_output[2];
		
		RS_tree = "";
		RS_tree = "
;S000= drawLast drawFirst
;the first line is the start point of rendering sequence
S000=   " + (RS_output[1] as string) + " 0";
		for i=1 to RS_output[2].count do (
			
			_id = "S" + MakeNumber (i-1) + "=";
			
			RS_tree += "\n" + _id  + "   "  + RS_output[2][i] as string;
		)
		
		--print RS_tree;
		-- +++++++++++++++++++++++++++++++++++++++
		
		
		
	
	)
	
	endTime = timeStamp();
	format "Processing function ( RS_makeRS ) took % seconds\n" ((endTime - startTime) / 1000.0);
	
	return RS_tree;
	
)

-- ###################################################################











-- ###################################################################
--  FILE I/O main FUNCTIONS


-- FC :: ...
function importTXT filename get_importsettings = (
	
		
	-- Display Filename
	tmp = "filename is : " + filename as string
	print tmp
	
	-- just a Test: headerInfo.headerINI.text = "999"
	
	
	-- Setup vars
	-- main arrays
	header_array = #();
	insert_array = #();
	vert_array = #();
	elements_array = #();
	poly_array = #();
	normals_array = #();
	
	-- secondary arrays
	tVert_array = #();
	tVertB_array = #();
	tVertCount = 0;
	tFace_array = #();
	actionCode_array = #();
	createdFaces_array = #();
	elementsNode_array = #();
	polyToElement_array = #();
	dummy_array = #();
	
	isheaderLine = false;
	usefullLine = false;
	
	
	-- ##########
	-- Parse TXT String
	-- ##########
	
	print "#####################################"
	print "_______________ PARSE TXT STRING"
	print "#####################################"
	
	
	getFile = openFile filename;
	
	if getFile != undefined then (
		
		
		-- check if file is ok
		seek getFile #eof;
		local filelength = filepos getFile;
		seek getFile 0;
		fileAsString = readChars getFile filelength errorAtEOF:false
		seek getFile 0;
		
		format  "filelength = % \n" filelength;
		--print "fileAsString";
		--print fileAsString;
		
		if fileAsString == "" then (
			tmp= "!!! ERROR !!! - file is empty or unsupported";
			--format "check -> % \n" tmp;
			return tmp;
		)

		
		
		
		-- parse through the file, line by line
		k=0;
		while eof getFile == false do (
			--print (readChar getFile);
			--print (readDelimitedString getFile "[");

			thisLine = readLine getFile;
			--print "k =";
			 --print k
			 --print thisLine
			
			
			-- used to look out for N(normals), E(elements), P(points), comments ;
			firstChar = substring thisLine 1 1;
			
			
			-- just look at lines with data in it and which are no comment lines
			if thisLine != "" and firstChar != ";" then (
				
				-- look out wich blook is parsed at the moment
				
				if thisLine == "[HEADER]" then (
					isheaderLine = true
					-- print "found header in line"
				)	
				if thisLine == "[INSERT]" or thisLine == "[NORMAL]" or thisLine == "[ELEMENTS]" or thisLine == "[POINTS]" then (
					usefullLine = true
					-- print "found usefull block start in line"
				)
				if thisLine == "[END]" then ( 
					usefullLine = false; isheaderLine = false;
					-- print "found end in line"
				)
				
				-- [HEADER]
				if firstChar != "[" then (
					if isheaderLine == true  then (
						-- print "this is header stuff going on"
						-- header_array
						-- ini
						-- texture
						-- parts
						-- points
						-- elements
						-- preview
						
						
						tmpA = #();
						tmpA = filterstring thisLine "=";
						if tmpA.count == 1 then tmpA[2] = "<empty>";
						if tmpA.count > 2 then print "!! WARNING !! there is not more then one '=' per [HEADER]-line allowed"
						
						join header_array tmpA;
					)
				)
				
				-- process only the important data types
				if usefullLine == true then (
					
					if firstChar == "I" or firstChar == "N" or firstChar == "E" or firstChar == "P" then (
						-- print "this line is usefull, it is an"
						-- print firstChar
						
					
						-- used to look out for the ID number of an value
						idChars = (substring thisLine 2 3) as integer +1
						
						-- gets the pure data from a line
						dataChars = substring thisLine 6 -1

						-- array with all data from this line
						tmp_A1 = #()
						tmp_A1 = filterString dataChars " " 
						-- print "tmp_A1 of this line"
						-- print tmp_A1 #nomap;
						

						-- parse [INSERT] information
						if firstChar == "I" then (
							-- print "ein I gefunden mit der Nummer"
							-- print idChars
							-- print dataChars
							
							insert_array[idChars] = #(tmp_A1[1], tmp_A1[2], tmp_A1[3], tmp_A1[4], tmp_A1[5])
							-- print "insert_array of this line"
							-- print insert_array[idChars] #nomap;
							
							-- create a bone for every INSERT
							--format "create bone NR. % \n" idChars as string
							-- b1 = bone name:("Insert_cod=" + tmp_A1[1] + "_num=" + tmp_A1[2] + "_" + idChars as string)  pos:[0,0,0]; 
							tmp = "Insert_cod=" + tmp_A1[1] + "_num=" + tmp_A1[2] + "_" + (idChars-1) as string;
							tmp = (tmp as string)
							-- execute("b" + idChars as string + " = dummy name:(\"" + tmp + "\")  pos:[0,0,0]" );
							dummy_array[idChars] = dummy name:( tmp )  pos:[0,0,0]
							--execute ("print b" + idChars as string);
						)
						
						-- parse [NORMAL] information
						if firstChar == "N" then(
							-- print "ein N gefunden mit der Nummer"
							-- print idChars
							-- print dataChars
							
							-- write data into vertex array
							normals_array[idChars] = #(tmp_A1[1], tmp_A1[2], tmp_A1[3], tmp_A1[4], tmp_A1[5], tmp_A1[6])
							-- print "normals_array of this line"
							-- print normals_array[idChars] #nomap;
						)
						
						-- parse [VERTEX] information
						if firstChar == "P" then(
							-- print "ein P gefunden mit der Nummer"
							-- print idChars
							-- print dataChars
							
							-- write data into vertex array
							vert_array[idChars] = #(tmp_A1[1], tmp_A1[2], tmp_A1[3], tmp_A1[4])
							-- print "vert_array of this line"
							-- print vert_array[idChars] #nomap;
						)
						
						-- parse [ELEMENT] information (elements are NOT ONLY polygons !!!!!!!!!!!!! but lines and hardpoints too !!!!!! which dont have faces or tFaces)
						if firstChar == "E" then(
							-- print "ein E gefunden mit der Nummer"
							-- print idChars
							-- print dataChars

							-- write data into face array
							elements_array[idChars] = tmp_A1;
							-- print "elements_array of this line"
							-- print elements_array[idChars] #nomap;
							
							
							-- get ACTION CODE Array
							if elements_array[idChars][1] as integer > 6 and elements_array[idChars][1] != "255" then (
								-- print "found an action code::"
								tmpA = #();
								tmpA[1] = elements_array[idChars][1];
								tmpA[2] = elements_array[idChars][2];
								actionCode_array[idChars] = tmpA;
								
								
								-- print actionCode_array[idChars][1]
								-- print actionCode_array[idChars][2]
								
								elements_array[idChars] = deleteItem elements_array[idChars] 1;
								elements_array[idChars] = deleteItem elements_array[idChars] 1;
								
							)
							
							-- get color_index Array
							--#
							--#
							--#
							--#
							
							
							
							
							-- for LINE only (Code 1)
							if elements_array[idChars][1] as integer == 1 then (
								/*
								tmpA = #();
								for j=1 to 2 do(
									tmpA[j] = #(elements_array[idChars][j*2+1], elements_array[idChars][j*2+2], 0);
									
									append tVertB_array tmpA[j]
								)
								tVert_array[idChars] = tmpA;
								*/
							)
							
							
							
							
							
							-- only for code-3 polys (single colored)
							-- convert element to match code 5 - poly string, therefor insert (0,0) texture coordinates
							if (elements_array[idChars][1] as integer) == 3  then (
								tmpA = #();
								for j=1 to elements_array[idChars].count as integer do (
									append tmpA elements_array[idChars][j];
									if j > 2 and j <= (elements_array[idChars][2] as integer)+2 then (
										append tmpA "0";
										append tmpA "0";
									)
								)
								--append poly_array tmpA;
								--append polyToElement_array idChars;
								elements_array[idChars] = tmpA;
							)
							
							-- only for code-4 polys (multi colored)
							-- convert element to match code 5 - poly string, therefor insert (0,0) texture coordinates
							if (elements_array[idChars][1] as integer) == 4  then (
								tmpA = #();
								for j=1 to elements_array[idChars].count as integer do (
									
									if j > 2 and j <= (elements_array[idChars][2] as integer)*2+2 then (
										-- if even (== former color_index value)
										if (mod j 2) == 0 then (
											append tmpA "0"; -- (== V)
										)
										-- else (== node ID)
										else (
											append tmpA elements_array[idChars][j];
											append tmpA "0"; -- (== U)
										)
									)
									else (append tmpA elements_array[idChars][j]);
									
								)
								--append poly_array tmpA;
								--append polyToElement_array idChars;
								elements_array[idChars] = tmpA;
							)
							
							
							
							
							
							
							-- get UV Texture coordinates Array and poly_array
							-- Vars created here:        tVert_array       tVertB_array            poly_array
							-- only for polys  (type 5 and 6 and the converted type 3 and 4 (see above)) 
							-- duplicates MUST be saved here
							if (elements_array[idChars][1] as integer) > 2 and (elements_array[idChars][1] as integer) < 7 then (
								tmpA = #();
								for j=1 to elements_array[idChars][2] as integer do (
									tmpA[j] = #(elements_array[idChars][j*3+1], elements_array[idChars][j*3+2], 0);
									append tVertB_array tmpA[j];
								)
								append tVert_array tmpA;
								append poly_array elements_array[idChars];
								
								append polyToElement_array idChars;
							)
							
							
							
							
							
						)
						
						
					)
					
				)
				
				-- everything else
				/*
				if thisLine != "" then (
					
					print "### USELESS LINE ### "
					print i
					print thisLine
					print "## -- ##"
					
				)
				else print "... empty line ..."
				*/
				
				
			)	
			
			-- print "_______________________________ END OF LINE PROCESSING _______________________________"
			
			k = k+1;
			
		) -- End :: while
		
				
	) -- End :: if getFile != undefined-
	
	close getFile;


	
	
	-- ##############################################################################
	-- ____________________________________________ END PARSING
	-- ##############################################################################

	
	
	
	
	-- count Elements
	elementsCount = elements_array.count;
	
	
	
	
	
	-- create elementToPoly_array
	elementToPoly_array = #();
	for i=1 to elementsCount do (
		elementToPoly_array[i] = "this Element is no poly";
	)
	for i=1 to polyToElement_array.count do (
		elementToPoly_array[polyToElement_array[i]] = i;
	)
	
	
	
	-- creates an array with the node IDs
	polyNodes_array = #()
	for i=1 to poly_array.count do (
		tmpA = #();
		for k=1 to poly_array[i][2] as integer do (
			--print "poly_array of poly ";
			--print i;
			--print poly_array[i];
			tmpA[k] = poly_array[i][k*3] as integer +1 -- +1 to match max intern start with 1
			polyNodes_array[i] = tmpA;
		)
	)
	
	-- create texture FACE array
	k=1;
	for i=1 to tVert_array.count do (
		tmpA = #();
		for j=1 to tVert_array[i].count do (
			tmpA[j] = k;
			k = k+1;
		)
		tFace_array[i] = tmpA;
	)
	
	
	-- create duplicate poly array
	-- for every poly...
	print " ---------- DUPLICATE CHECK ----------";
	tmpAllgDupArray = #();
	
	duplicatePoly_array = #();
	for i=1 to polyNodes_array.count do (
		-- format "checking poly % \n" i;
		
		tmpNrOfDuplicates = 0;
		tmpLocalDupArray = #();
		-- ... check every remaining poly ..
		for k=i+1 to polyNodes_array.count do (
			-- format "comparing it with poly % \n" k;
			-- ... check if poly not already found as duplicate
			-- print "test :: ";
			-- print( findItem tmpAllgDupArray k );
			
			if findItem tmpAllgDupArray k == 0 then (
				-- print "poly is not already a duplicate";
				-- .. check first if node counts match
				if polyNodes_array[i].count == polyNodes_array[k].count then (
					-- print "node count does match";
					-- .. compare every node
					tmpMatchCount = 0;
					for j=1 to polyNodes_array[i].count do (
						-- check if every node ID match
						-- format "comparing node % with node % \n" polyNodes_array[i][j] polyNodes_array[k][j]
						
						if polyNodes_array[i][j] == polyNodes_array[k][j] then (
							tmpMatchCount = tmpMatchCount +1;
							-- format "found % node match(es) \n" tmpMatchCount;
						)
						-- else print "these two nodes do not match";
					)
					if tmpMatchCount == polyNodes_array[i].count then (
						-- print "i found a duplicate";
						tmpNrOfDuplicates = tmpNrOfDuplicates + 1;
						
						if tmpNrOfDuplicates == 1 then (
							append tmpLocalDupArray i
						)
						append tmpLocalDupArray k;
					)
					-- else print "no complete match";
					/*
					if tmpLocalDupArray.count >0 then (
						join tmpAllgDupArray tmpLocalDupArray;
						append duplicatePoly_array tmpLocalDupArray;
					)
					*/
				)
				-- else print "node count does NOT match";
			)
			-- else print "poly IS already a duplicate";
		)
		
		if tmpLocalDupArray.count >0 then (
			join tmpAllgDupArray tmpLocalDupArray;
			append duplicatePoly_array tmpLocalDupArray;
		)
	)
	--print " _ duplicatePoly_array";
	--print duplicatePoly_array;
	
	
	
	--print " _ header array:" 
	--print header_array #nomap
	
	
	--print "_ insert array:" ;
	--print insert_array;
	insertCount = insert_array.count;
	--format "insertCount = %\n" insertCount;
	
	
	--print " _ vertex array:" ;
	--print vert_array;
	
	--print " _ elements_array :: " ;
	--print elements_array;
	--print " _ elements_array.count ::"
	--print elementsCount;
	
	--print " _ poly array";
	--print poly_array;
	
	--print " _ poly To Element array"
	--print polyToElement_array;
	
	--print " _ elementToPoly_array ::"
	--print elementToPoly_array;
	-- print" _ elementToPoly_array.count :: "
	-- print elementToPoly_array.count
	
	
	-- print " _ tVert array";
	-- print tVert_array;
	-- print " _ tVertB array";
	-- print tVertB_array;
	tVertCount = tVertB_array.count;
	-- print tVertCount;
	-- print " _ tFace array";
	-- print tFace_array;
	
	
	--print " _ polyNodes_array";
	--print polyNodes_array;
	
	
	--print " _ actionCode array";
	--print actionCode_array;

	-- print " _ normals_array:" ;
	-- print normals_array;
	--print "-------------------------------";
	
	
	
	
	
	-- CHECKS !!! IMPORTANT
	
	-- check if there are elements
	if elementsCount == 0 then (
		tmp= "!!! ERROR !!! - no Elements found (check 3dz-txt file)";
		--format "check -> % \n" tmp;
		return tmp;
	)
	
	-- check if there are the same amount of normals and elements
	if elementsCount != normals_array.count then (
		tmp= "!!! ERROR !!! - the count of elements ( [ELEMENTS] ) and normals ( [NORMAL] ) differ!!";
		--format "check -> % \n" tmp;
		return tmp;	
	)
	-- check if there is an HEADER, INSERT, NORMAL, POINTS and ELEMENTS part
	
	
	
	
	
	
	-- ##########
	-- Create mesh
	-- ##########
	
	print "#####################################"
	print "_______________ CRATE MESH"
	print "#####################################"
	
	-- ep1 = editable_mesh name:(uniquename "EPoly") --create an empty EMesh
	-- convertTo ep1 (Editable_Poly) --convert to Editable_Poly
	
	em1 = editable_mesh name:(uniquename "EMesh") --create an empty EMesh

	
	
	
	
	-- ...................................................
	-- process vertex by VERTEX ( edit MESH )
	-- ...................................................
	setNumVerts em1 vert_array.count;
	for i=1 to vert_array.count do (
		x = vert_array[i][3] as integer
		y = vert_array[i][1] as integer
		z = vert_array[i][2] as integer
		-- E MESH
		setVert em1 i [x , y, z ];
	)
	
	
	
	
	
	-- ...................................................
	-- process element by ELEMENT
	-- ...................................................
	
	tmp3pointFacesCounter = 0;
	hardpointVerts = #();
	
	for i=1 to elements_array.count do (
		
		-- print "_________ processing one ELEMENT _________"
		-- print i
		
		-- Element types:
		-- 1 = Single-colored Line 			= Node # 1, Node # 2, Color Index in the P####TEX.TPC
		-- 2 = Insertion Point ("Hardpoint") 	= Index in the LOADOUT.DAT file, Node #
		-- 3 = Single-colored Polygon			= Total number of Nodes, Node # 1, Node # 2, [...],Color Index in the P####TEX.TPC
		-- 4 = Multiple-colored Polygon			= Total number of Nodes, Node # 1, Color Index # 1, Node #2, etc.
		-- 5 = Textured Polygon
		-- 6 = Textured Polygon with Alph	
		
		
		-- 255 == skip
		if elements_array[i][1] != "255" then (
				
			
			-- print "current element(s) data::"
			-- print elements_array[i] #nomap
			
			
			-- LINE
			if elements_array[i][1] == "1" then (
				-- print "it's a line (Code 1)"
				-- 2 = node 1
				-- 3 = node 1 - U
				-- 4 = node 1 - V
				-- 5 = node 2
				-- 6 = node 2 - U
				-- 7 = node 2 - V
				-- 8 = colour index
				-- 9 = endofline
				
				
				-- create a spline-line
				
			)
			
			-- HARDPOINT
			if elements_array[i][1] == "2" then (
				
				 -- print "it's a hardpoint (Code 2)"
				-- 2 = index in loadout.dat
				-- 3 = node 1
				-- 4 = endofline
				
				-- create 
				
				-- save hardpoint nodes for later use
				append hardpointVerts (elements_array[i][3] as integer + 1);
				
				-- position
				local x = vert_array[elements_array[i][3] as integer + 1][3] as integer
				local y = vert_array[elements_array[i][3] as integer + 1][1] as integer
				local z = vert_array[elements_array[i][3] as integer + 1][2] as integer
				
				-- rotation based on the normal vector
				local normal_x = normals_array[i][3] as integer;
				local normal_y = normals_array[i][1] as integer;
				local normal_z = normals_array[i][2] as integer;
				
				--rot_x = normalToRotation normal_y normal_z;
				--rot_y = normalToRotation normal_z normal_x;
				--rot_z = normalToRotation normal_y normal_x;
				--normal_c =
				--normal_d =
				
				
				
				-- hardpoint = PointHelperObj name:(uniquename ("Hardpoint_index=" + elements_array[i][2] + "_") ) rotation:(eulerangles rot_x rot_y rot_z) pos:[x,y,z]  axistripod:true cross:true centermarker:true;
				
					local anglesA = normal2rotation [normal_x, normal_y, normal_z];
			
					local rot_x = anglesA[2];
					local rot_y = 0;
					local rot_z = anglesA[1];
					
					/*
					print "rotations x y z ::";
					print rot_x;
					print rot_y;
					print rot_z;
					*/
										
					local hardpoint = PointHelperObj name:(uniquename ("Hardpoint_index=" + elements_array[i][2] + "_") ) rotation:(eulerangles 0 0 0) pos:[x,y,z]  axistripod:true cross:true centermarker:true;
					rotate hardpoint (eulerangles 0 0 rot_z);
					in coordsys local rotate hardpoint (eulerangles rot_x 0 0 );
				
			)
			
			
			
			-- POLYGONE
			
			/* -- element types 3 and 4 are already converted to type5 syntax
			if elements_array[i][1] == "3" then (
				--print "it's a multi colored polygon (Code 3)";
				-- 2 = number of nodes (n)
				-- 3-n = node id's
				-- n+1 = color index
				-- n+2 = color index
				-- n+3 = color index
				-- n+4 = color index
				-- n+5 = endofline
				print "dropping a single colored polygone (Code 3)";
			)
			
			if elements_array[i][1] == "4" then (
				--print "it's a multi colored polygon (Code 4)";
				print "dropping a multible colored polygone (Code 4)";
			)
			*/
			
			if elements_array[i][1] == "3" or elements_array[i][1] == "4" or elements_array[i][1] == "5" or elements_array[i][1] == "6" then (
				--print "it's a polygon (Code 5 or 6)";
				
				-- nodeCount =  elements_array[i][2] as integer
				local thisPolyID = elementToPoly_array[i];
				nodeCount =  poly_array[thisPolyID][2] as integer;
				
				-- creates an array with the node numbers 
				tmpNodesArray = #()
				for k=1 to nodeCount do (
					local tmpVertID = poly_array[thisPolyID][k*3] as integer +1 -- +1 to match max intern start with 1
					-- if node is not already stored ... debug funktion.. avoid polys like this #(1,4,6,1) --- 1 is here doubled
					--format "looking at node nr % \n" k;
					--format "vert id = % \n- tmpNodesArray :: %" tmpVertID tmpNodesArray;
					
					if (finditem tmpNodesArray tmpVertID) == 0 then (
						append tmpNodesArray tmpVertID;
					)
					-- this is a warning value
					--else tmpNodesArray[k] = -1;
				)
				--print " _ final tmpNodesArray";
				--print tmpNodesArray;
				--print "---------";
				-- Reverse the Array to get right face normals on creation
				tmpNodesArrayReversed = for k = tmpNodesArray.count to 1 by -1 collect tmpNodesArray[k]
				
				-- attrib2 == color_index; look at "get color_index Array"
				-- attrib2 = poly_array[thisPolyID][nodeCount*3 + 4] as integer
				-- print "attribute 2"
				-- print attrib2
				
				
				
				
				-- ######### --- MESH --- ########
				
				-- check if poly is already there 
				-- if so, do not create a new one (wont work anyway) but 
				-- check which faces are representing the already existing poly
				-- (give these faces a new uv-channel and apply the tVert coordinates of this new poly to them) not implemented yet
				
				-- for every group of duplicates..
				tmpThisElementIsDuplicate = -1;
				for k=1 to duplicatePoly_array.count do (
					-- format "element im working on % duplicate group im looking at % \n" elementToPoly_array[i] k;
					-- print duplicatePoly_array[k];
					
					tmp = findItem duplicatePoly_array[k] elementToPoly_array[i];
					
					-- format "result of search % \n" tmp;
					
					-- check if poly is first item within the duplicates group...
					-- ... if so, it is NOT a duplicate but the root itself.. 
					-- .. so go on and create the poly
					if tmp != 1 and tmp !=0 then (
						-- print "found an duplicate, stopping for";
						tmpThisElementIsDuplicate = duplicatePoly_array[k][1];
						-- stop for
						k = duplicatePoly_array.count;
					)
					if tmp == 1 then (
						-- print "found duplicate but it is the root element";
					)
					if tmp == 0 then (
						-- print "found no duplicate";
					)
				)
				
				
				
				-- create one edit Mesh Polygon based on the vertice defined within the node array .. ex. #(2, 18, 44, 28, 101)
				
				tmpFaceBefore = em1.numfaces;
				if tmpThisElementIsDuplicate == -1 then (
					-- format "all ok.. ill create this element % as faces \n" i;
					if actionCode_array[i] == undefined then thisMatID = 1; -- debuging.. later it will be re
					else thisMatID = (actionCode_array[i][1]  + actionCode_array[i][2]) as integer - 1;
					--format "thisMatID == % and smGroup = % \n" thisMatID (elements_array[i][1] as integer);
					
					-- convert decimal into binary
					-- smGroupBit works this way -> if smGroupBit == 4 is the corresponding binary value 0100 ...
					-- ... which means that sg 3 is activated
					smGroupBit = 1 * 2^(poly_array[thisPolyID][1] as integer - 1);
					
					tmp = meshop.createPolygon em1 tmpNodesArrayReversed smGroup:(smGroupBit) matID:(thisMatID);
					
				)
				else (
					-- format "element % is a duplicate of poly %, i dont create the faces... \n" i tmpThisElementIsDuplicate ;
				)
				tmpFaceAfter = em1.numfaces;
				
				-- create createdFaces_array
				if tmp != OK or tmpFaceBefore == tmpFaceAfter then (
					format "!!!!!!!!!!!!!!!!!! ---- ATTENTION - WARNING ---- !!!!!!!!!!!!!!!!!! \n ----------- element % was not created as faces \n" i;
					format "using these nodes (reversed) :: % \n \n" tmpNodesArrayReversed;
					
					append createdFaces_array "no faces created";
				)
				else (
					
					--format "create poly % -> % \n" i tmp;
					
					-- save which faces are created
					-- ----------
					-- number of created 3point faces
					tmpCreated3pointFaces = tmpFaceAfter - tmpFaceBefore;
					
					tmpA = #();
					for k=1 to tmpCreated3pointFaces do (
						-- increase counter for every created tri
						tmp3pointFacesCounter = tmp3pointFacesCounter + 1;
						-- save this number as the new tri ID
						tmpA[k] = tmp3pointFacesCounter;
					)
					append createdFaces_array tmpA;
				)
				
				
				
				
				
				
				
				
				
				
				if elements_array[i][1] == "3" then (
					-- print "its a single coloured poly"
					-- not sure if there is uv data
					-- 2 = total number of nodes
					-- 3 = node 1
					-- 4 = node 1 U
					-- 5 = node 1 V
					-- 6 = node 2
					-- 7 = node 2 U
					-- 8 = node 2 V
					-- ...
					-- elements_array.count - 1 = colour index
					-- elements_array.count = endofline
				)
				if elements_array[i][1] == "4" then (
					-- print "its a multible coloured poly"
					-- not sure if there is uv data
					-- 2 = total number of nodes
					-- 3 = node 1
					-- 4 = node 1 U
					-- 5 = node 1 V
					-- 6 = node 1 colour index
					-- 7 = node 2
					-- 8 = node 2 U
					-- 9 = node 2 V
					-- 10 = node 2 colour index
					-- ...
					-- elements_array.count = endofline
				)
				if elements_array[i][1] == "5" then (
					-- print "its a poly with texture"
					-- 2 = total number of nodes
					-- 3 = node 1
					-- 4 = node 1 U
					-- 5 = node 1 V
					-- 6 = node 2
					-- 7 = node 2 U
					-- 8 = node 2 V
					-- ...
					-- elements_array.count - 2 = 0-pointer
					-- elements_array.count - 1 = Element Attribute / Color Index
					-- elements_array.count = endofline
				)
				if elements_array[i][1] == "6" then (
					-- print "its a poly with transparency"
					-- 2 = total number of nodes
					-- 3 = node 1
					-- 4 = node 1 U
					-- 5 = node 1 V
					-- 6 = node 2
					-- 7 = node 2 U
					-- 8 = node 2 V
					-- ...
					-- elements_array.count - 2 = 0-pointer
					-- elements_array.count - 1 = Element Attribute / Color Index
					-- elements_array.count = endofline
				)
				
			)
		
		)
	
	)
	
	print "................................... END MESH CREATION .......................................";
	
	
	
	
	
	
	/*
	print "created 3point faces array";
	for i=1 to createdFaces_array.count do(
		format "Poly ID % -> createdFaces :: % \n" i createdFaces_array[i]
	)
	*/
	
	-- create Array where i can see which face had belong to which element
	faceToPoly_array = #();
	
	for i=1 to createdFaces_array.count do (
		for k=1 to createdFaces_array[i].count do (
			if createdFaces_array[i] == "no faces created" then (
				
			)
			else (
				faceToPoly_array[createdFaces_array[i][k]] = i; 
			)
		)
	)
	
	/*
	print " _ faceToPoly_array";
	for i=1 to faceToPoly_array.count do (
		format "Face ID: % -> Poly ID: %  -> Element ID: % \n" i faceToPoly_array[i] polyToElement_array[faceToPoly_array[i]];
	)
	*/
	-- _______________________________________________
	
	
	
	
	
	
	
	-- ##########
	-- Create UVs
	-- ##########
	
	print "#####################################"
	print "_______________ CRATE UV COORDINATES"
	print "#####################################"
	
	
	
	-- create all textur VERTICES 
	setNumTVerts em1 tVertCount;
	
	-- print( "tVert count NOW = ");
	-- print( getNumTVerts em1 );

	for i=1 to tVertCount do (
		-- print "create tvert"
		-- print i;
		-- convert uv coordinates
		
		u = tVertB_array[i][1] as float / 254; -- divide through 254 bc original range is from 0-254 but max range is from 0-1
		v = tVertB_array[i][2] as float / 254;
		w = tVertB_array[i][3] as float / 254;
		
		setTVert em1 i [u, v, w];	
		
	)
	
	

	-- create all textur FACES
	buildTVFaces em1;
	for i = 1 to getNumFaces em1 do(
		-- format "\n create tface of face :: % \n" i;
				
		-- face ID == i
		-- find out to which element this face had belong
		local thisPolyID = faceToPoly_array[i];
		-- format "this face: % had belong to poly % and element % \n" i thisPolyID polyToElement_array(thisPolyID);
		-- format  "this poly % looks like this::" thisPolyID;
		-- print poly_array[thisPolyID] #nomap;
		
		-- Main Goal: find the coresponding tVert IDs for the following Vert IDs 
		-- get vert IDs of this face
		tmp = getFace em1 i;
		thisVerticeIDs = #(tmp.x, tmp.y, tmp.z);
		-- print "vertice IDs of this face ::";
		-- print thisVerticeIDs;
		
		tmpA = #();
		
		-- for every of the three vertice a triangle has ...
		for j=1 to 3 do (
			-- print "--------------------";
			-- print "searching vertex";
			-- print thisVerticeIDs[j];
			
			-- go from node to node of the corresponding poly...
			-- ... and look if it is one of the vert IDs of this face
			for k=1 to (poly_array[thisPolyID][2] as integer) do (
				-- print "scanning node";
				-- print k;
				
				lookUpElement = poly_array[thisPolyID][k*3] as integer + 1;
				
				-- print "compare vertice with ::";
				-- print lookUpElement;
				
				-- if matching IDs
				if lookUpElement == thisVerticeIDs[j] then (
					-- print "match";
					-- save for every vertex the nodeID position (1st, 2nd, ...) and...
					tmpA[j] = k;
				)
				-- else (print"no match";)
			)
		)
		
		-- print "position of matching vertex ID";
		-- print tmpA #nomap;
		
		-- print "this polyID ::";
		-- print thisPolyID
		
		
		
		-- ... use this position to gain the corresponding tVert ID for every vertex and...
		thisTVertIDs = #(tFace_array[thisPolyID][tmpA[1]], tFace_array[thisPolyID][tmpA[2]], tFace_array[thisPolyID][tmpA[3]] );
		-- print "thisTVertIDs::"
		-- print thisTVertIDs #nomap;
		
		
		-- ... create, or better SET the textur face based on these three tVert IDs
		tmp = setTVFace em1 i [ thisTVertIDs[1], thisTVertIDs[2], thisTVertIDs[3] ];
		-- print tmp;
	)
	
	-- ........................................................................................................
	-- Ende UV cration 
	--  ..........................................................................................................................................................
	
	
	
	
	
	
	
	
	-- ##########
	-- Apply Skinning
	-- ##########
	
	print "#####################################"
	print "_______________ CRATE SKIN MODIFIER"
	print "#####################################"
	
	
	
	addmodifier em1(skin draw_vertices:true);
	em1.modifiers[#Skin].bone_Limit = 1;
	max modify mode; -- switch to modify pannel
	select em1; -- select object and with it the skin modifier
	
	-- create root bone 
	b0 = dummy name:("rootBone") pos:[0,0,0];
	skinOps.addbone em1.modifiers[#Skin] b0 1;
	
	
	-- adds the bones to skin modifier
	-- !!!!!! problem: start max and run the script for the first time
	-- error -> Unknown property: "modifiers" in undefined <<
	for i=1 to insert_array.count do (
		-- format "execute this string:: % \n" ("skinOps.addbone em1.modifiers[#Skin] b" + i as string + " 1");
		-- execute ("skinOps.addbone em1.modifiers[#Skin] b" + i as string + " 1");
		skinOps.addbone em1.modifiers[#Skin] dummy_array[i] 1
		
		-- dummy settings setup (has nothing to do with the skin modifier
		-- dummy_array[i].showLinksOnly = true;
	)
	
	
	
	-- set vert assignment
	-- first set all vert weight to the rootBone for initialisation
	/*
	print "vert array ::";
	print vert_array;
	
	print "skin verts ::"
	print (skinOps.getNumberVertices em1.modifiers[#Skin]);
	*/
	completeRedraw ()
	-- print "skin verts NOW ::"
	-- print (skinOps.getNumberVertices em1.modifiers[#Skin]);
	
	-- debug check
	--print "skin verts compared to vertex array ::";
	--print (skinOps.GetNumberVertices em1.modifiers[#Skin]);
	--print vert_array.count;
	if (skinOps.GetNumberVertices em1.modifiers[#Skin]) != vert_array.count then (
		tmp = "!!! ERROR !!! - Vertex count mismatch. Reset scene, restart tool and try again";
		return tmp;
	)
	
	-- read through the vertex array and depending on the insert-link set the weighting 
	for i=1 to vert_array.count do (
		--print i;
		if vert_array[i][4] as integer == 0 then (
			--print "vertex belongs to root";
			 skinOps.SetVertexWeights em1.modifiers[#Skin] i 1 1.0;
		)
		else (
			-- format "vertex belongs to bone % \n" vert_array[i][4];
			-- execute ("skinOps.SetVertexWeights em1.modifiers[#Skin] " + i as string + " " + (vert_array[i][4] as integer + 1) as string + " 1.0");
			skinOps.SetVertexWeights em1.modifiers[#Skin]  i  (vert_array[i][4] as integer + 1)   1.0;
		)
	)
	
	-- move the bones to the positions marked within the insert-array
	for i=1 to insert_array.count do (
		
		x = insert_array[i][5] as integer;
		y = insert_array[i][3] as integer;
		z = insert_array[i][4] as integer;
		p3 = [x,y,z];
		
		-- execute("move b" + i as string + " " + p3 as string);
		move dummy_array[i] p3;
	
	)
	
	
	
	print "#####################################"
	print "_______________ SET MATERIAL"
	print "#####################################"
	
	texMap = bitmaptex filename:(header_array[4]);
	em1.material = standardMaterial diffusemap:(texMap);
	
	
	
	print "#####################################"
	print "_______________ FINAL SETTINGS"
	print "#####################################"
	
	-- set backface culling
	em1.backFaceCull = false;
	
	-- create bounding box
	--boundingBox = box name:("boundingBox") pivot:[0,0,255] pos:[0,0,0] lengthsegs:1 widthsegs:1 heightsegs:1 length:(2*254) width:(2*254) height:(2*254);
	--boundingBox.boxMode = true;
	
	
	
	
	print "#####################################"
	print "_______________ CLEAN UP"
	print "#####################################"
	
	-- remove hardpoint only verts
	--print "hardpointVerts"
	--print hardpointVerts;
	hardpointOnlyVerts = #();
	for i=1 to hardpointVerts.count do (
		-- check if vertex is not used by any poly or edge
		--print "check vert" 
		--print hardpointVerts[i];
		local tmp = (meshop.getFacesUsingVert em1 hardpointVerts[i]) as array;
		--print "attached faces :";
		--print tmp;
		--print tmp.count;
		if tmp.count == 0 then (
			append hardpointOnlyVerts hardpointVerts[i];
			print "found hardpoint only node (vertex)";
		)
		else print "this hardpoint node (vertex) is NO hardpoint only one";
	)
	print "hardpointOnlyVerts: these nodes (verts) will be removed";
	print hardpointOnlyVerts;
	meshop.deleteVerts em1 (hardpointOnlyVerts as bitarray);
	update em1;
	
	
	
	
	-- remove isolated vertices
	if get_importsettings[1] == 1 then (
		meshop.deleteIsoVerts em1;
		/*
		max modify mode; -- change to modify pannel
		select em1;
		modPanel.setCurrentObject $.baseObject
		subObjectLevel = 1; -- change subobject level to vertex
		meshOps.removeIsolatedVerts em1; -- press the button 
		subObjectLevel = 0; -- leave subobject level
		deselect em1;
		*/
		print "isolated/unused Verts(Nodes) removed";
	)
	else print "isolated/unused Verts(Nodes) _NOT_ removed";
	
	
	
	
	return "Import was successful";
	
	
) -- End funktion importTXT



-- FC :: ...
function exportTXT filename2 get_settings headerStuffArray = (
	
	
	-- SETTINGS
	normalExportFormat = get_settings[1];
	removeBulkheads = get_settings[2];
	calculateRS = get_settings[3];
	mainCutPlane = get_settings[4];
	
	
	
	format " calculateRS = % \n" calculateRS;
	
	
	print "function exportTXT";
	
	
	
	print "########################################";
	print "______________PRE-CHECK"
	print "########################################"
	
	(
		local foundRootBone = false;
		local tmpEmeshCount = 0;
		local hasSkinM = false;
		
		for i=1 to selection.count do (
			if isValidNode selection[i] then (
				if classof selection[i] == Dummy then (
					if selection[i].name == "rootBone" then (
						foundRootBone = true;
					)
				)
				if classof selection[i] == Editable_mesh or classof selection[i] == PolyMeshObject or classof selection[1] == Editable_Poly then (
					tmpEmeshCount += 1;
					if  selection[i].modifiers[#Skin] != undefined then hasSkinM = true;
				)
			)
		)
		
		
		
		if foundRootBone and tmpEmeshCount == 1 and hasSkinM then (
		 -- ok
		)
		else (
			tmp = "!! ERROR !! you must select exactly one Editable_mesh/Edit_Poly + Skin modifier and at least the rootBone";
			--format "check -> % \n" tmp;
			format "\n foundRootBone = % ;tmpEmeshCount % ;hasSkinM = % \n" foundRootBone tmpEmeshCount hasSkinM;
			return tmp;
			)
	)
	
	
	
	print "########################################";
	print "______________SAVE MAX SCENE"
	print "########################################"
	--/* -- remove this line later , just for testing
	-- save max-file (but ask first)
	messagebox "You have to save this MAX scene first. \nThe scene will be automatically reloaded after the export"
	
	
	tmpFilename = getMAXSaveFileName filename:"tmp_3DZ_ExportScene"; -- get filename
	sceneWasSaved = false
	if tmpFilename != undefined then(
		print "the file the scene is saved to before export is :: "
		print tmpFilename
		
		-- if file does not already exist or user granted permission to overwrite already existing file
		if (not (doesfileexist tmpFilename)) or querybox ("Overwrite:\n "+ tmpFilename + "\n?") then ( 
			sceneWasSaved = saveMaxFile tmpFilename useNewFile:false -- save MAX File
		
			if sceneWasSaved == true then ( /*messagebox "saved";*/ )
			else messagebox "!! WARNING !! \n File cant be saved. Check for problems!";
		) 
		else messagebox "!! export stopped !! \n aborted by user";
	)
	else messagebox "!! export stopped !! \n no filename specified";
	-- */ sceneWasSaved = true; -- remove this line later , just for testing
		
	-- IMPORTANT.. continue with script only if max scene was saved successfully
	
	
	
	if sceneWasSaved then (

		print "########################################";
		print "______________EXPORT PREPARATIONS"
		print "########################################"
		
		allExportObjects = #();
		allExportObjects = selection as array;
		print allExportObjects;
		
		-- define vars
		em_array = #(); -- edit Mesh array
		dummyString_array = #();
		-- line_array = #();
		hardpoint_array = #();
		local tmpHardpointArray = #();
		
		vertsString_array = #();
		poly_array = #();
		polyUV_array = #();
		polyInfo_array = #();
		polyVerts_array = #();
		normalString_array = #();
		
		eMeshCounter = 0;
		
		global finalExportMesh = -1;
		
		
		for i=1 to selection.count do (
			--format " \n > this object (selection Nr = % ) is a :: % \n" i selection[i];
			
			
			if isValidNode selection[i] then (
				
				-- print "... is valid node";
				-- print (classof selection[i]);
				
				-- _______________________________________________________ DUMMY
				-- DUMMY == INSERT stuff
				-- example: Insert_cod=2_num=1_3
				-- ______Insert_cod=<codid>_num=<numid>_<insertid>
				if classof selection[i] == Dummy then (
					-- print ">______ found a dummy";
					
					-- save dummy coordinates and names
					-- format "dummy name is % \n" selection[i].name;
					-- format "dummy coordinates are  % \n" selection[i].pos;
					
					-- all bones except rootBone
					if selection[i].name != "rootBone" then (
					
						local tmpA = #();
						tmpA = filterstring selection[i].name "_";
						-- tmpA[1] == "Insert"
						-- tmpA[2] == cod=<codid>
						-- tmpA[3] == num=<numid>
						-- tmpA[4] == <insertid>
						
						-- set dummy_array values
						local tmpCodA = filterstring tmpA[2] "=";
						local tmpNumA = filterstring tmpA[3] "=";
						local _cod = tmpCodA[2];
						local _num = tmpNumA[2];
						
						insertID = "I" + (MakeNumber (tmpA[4] as integer )) + "= "; -- 
						x = selection[i].pos.x as integer;
						y = selection[i].pos.y as integer;
						z = selection[i].pos.z as integer;
						
						/*
						print "-- s --";
						print tmpA[4];
						print insertID;
						print "--  --";
						*/
						
						-- create dummy_array
						dummyString_array[tmpA[4] as integer + 1] = (  insertID as string + "     " +  _cod as string + "     " +  _num as string + "     " +  y as string + "     " +  z as string + "     " +  x as string );
						-- append dummyString_array (  "     " +  _cod as string + "     " +  _num as string + "     " +  y as string + "     " +  z as string + "     " +  x as string );
					
						-- move all dummys to [0,0,0] 
						selection[i].position = [0,0,0];
						
					)
				)
				
				-- _______________________________________________________ HARDPOINT
				-- POINT == HARDPOINT
				if classof selection[i] == Point then (
					--print ">______ found a point";
					
					/*
					local tmpA = #();
					local _index = #();
					tmpA = filterstring selection[i].name "_";
					-- tmpA[1] == "Hardpoint"
					-- tmpA[2] == index=<indexid> describes what kind of hardpoint it is (ex. 10 == propeller)
					-- tmpA[3] == max intern number
					
					if tmpA.count < 3 then (
							tmp= "!! ERROR !! found a Hardpoint with wrong Name! You always need the sheme 'Hardpoint_index=<hardpointCode>_<3dsmaxID>, for example: Hardpoint_index=3_01'";
							format "check -> % \n" tmp;
							return tmp;
					)
					
					--format "execute this tring = % \n" ("_" + tmpA[2]);
					execute("_" + tmpA[2]); -- _index
					_index = filterstring tmpA[2] "=";
					
					
					-- hardpoint_array[i][1] == index
					-- hardpoint_array[i][2] == position
					-- hardpoint_array[i][3] == normal ( == z-axis-vector)
					append hardpoint_array #(_index[2] as integer, selection[i].pos, (rotation2normal selection[i]) );
					*/
					append tmpHardpointArray (getHPinfo selection[i]);
					
				)
				
				-- _______________________________________________________ LINE
				-- SPLINE == Line
				
				
				
				-- _______________________________________________________ Editable_mesh 	/ 		Poly			
				-- Editable_mesh 
				
				-- 1. check if edit poly or edit mesh (modifiers)
					--ok
				-- 2. convert to editable_mesh (collapse modifier stack)
					--ok
				-- 3. freeze transformations
					-- ok
				
				
				
				if classof selection[i] == Editable_mesh or classof selection[i] == PolyMeshObject or classof selection[1] == Editable_Poly then (
					--print ">______ found a Edit Mesh";
					
					-- !!! WARNING !!!
					-- this is not working.. all eMeshes have to be merged to one first!!
					-- so atm the script does only work if there is just one eMesh selected!!!!
					eMeshCounter += 1;
					--print eMeshCounter;
					
					-- setvars
					local thisVerts_array = #();
					local thisMeshPolys = #();
					local thisPolyVerts_array = #();
					local thisPolyTverts_array = #();
					local thisPolyBit_array = #();
					local thisPolyUV_array = #();
					local thisPolyInfo_array = #();
					local thisNormals_array = #();
					local thisSkinWeight_array = #();
					local thisNormalString_array = #();
					local thisPolyToComponent_array = #();
					
					-- snapshot
					-- exportMesh = snapshotAsMesh selection[i];
					
					-- no snapshot bc of skin modifier
					exportMesh = selection[i];
					
					
					-- create thisSkinWeight_array
					-- it holds for every vertex the corresponding component Nr. ( == "dummy")
					-- Nr. 1 == rootBone 
					max modify mode; -- switch to modify pannel
					select exportMesh; -- select object and with it the skin modifier
					for j=1 to exportMesh.Verts.count do (
						-- check if vertex uses just one bone
						if skinOps.GetVertexWeightCount exportMesh.modifiers[#Skin] j  == 1 then (
							-- IMPORTANT:: the BoneID represents the position in the skin-modifier list
							-- IT DOES HAVE NOTHING TO DO WITH THE HARDPOINT ID
							-- example = Insert_cod=2_num=2_2
							-- so you have to order the dummys in the skin-modifier by yourself
							-- 1. comes the root bone, then Insert_cod=a_num=b_0, then Insert_cod=a_num=b_1  and so on...
							-- the rootBone gets the ID=1 and the first Insert Dummy the ID=2
							tmp = skinOps.GetVertexWeightBoneID exportMesh.modifiers[#Skin] j 1;
							--format "bone id or nr or so... :: % \n" tmp;
							
							thisSkinWeight_array[j] = tmp - 1; -- -1 to match the [INSERT] part... starts with 0 and without rootBone so the first Insert-Dummy with the BoneID=2 will be now 1 (thats stupid.. it should be 0)
						)
						else (
							errorM = "!! ERROR !! -- vertex uses more then one bone :: select skin modifier and set 'bone affect limit' to 1";
							-- skinOps.GetVertexWeightCount exportMesh.modifiers[#Skin] j;
							print errorM;
							return errorM;
						)
					)
					--print  "thisSkinWeight_array";
					--print thisSkinWeight_array;
					
					
					
					addModifier exportMesh (Edit_Mesh());
					ResetXForm exportMesh;
					collapseStack exportMesh; 
					--resetscale exportMesh;
					

					
					select allExportObjects; -- reselect all export-objects 
					/*
					print "all export objects ==";
					print allExportObjects;
					print "current selection ==";
					print selection;
					*/
					
					
					
					
					
					
					/*
					-- create poly_array and polyBit_array
					-- format "mesh faces count = % \n" (getNumFaces exportMesh);
					-- format "mesh edge count = % \n" exportMesh.Edges.count;
					-- check all edges
					for j=1 to exportMesh.Edges.count do (
						-- get bitarray tmpPoly with all polys that use this edge
						tmpPoly = meshop.getPolysUsingEdge exportMesh #(j) 
						
						-- print "----------create poly_array----------";
						-- format "\n";
						-- print "check if i alrady have this poly ::";
						--print tmpPoly;
						
						tmpFoundMatch = false;
						-- search through bitarray in reversed order
						for k=thisPolyBit_array.count to 1 by -1 do (
							--format "--> comparing :: new= %  <-->  % \n" tmpPoly thisPolyBit_array[k];
							-- if difference of bitarrays is 0 then both bitarrays are the same
							if  (tmpPoly - thisPolyBit_array[k]).isEmpty and (tmpPoly as array).count ==  (thisPolyBit_array[k] as array).count then ( 
								tmpFoundMatch = true; 
								--print "----> found match, => poly already stored ----> EXIT";
								exit;
							)
							else ( -- found a new poly
								-- debug -> if new poly is more-complete then already saved poly new = #{1..7} saved = #{1..5}
								-- important.. to solve max-bug
								--print "poly debug check"
								if  (tmpPoly * thisPolyBit_array[k]).isEmpty then(
									--print "----> poly is still new but i will continue checking.";
								)
								else (
									-- version 1 :: trying to build maximus size polys
									-- store new and more complete poly over old poly
									tmpFoundMatch = true; 
									thisPolyBit_array[k] = tmpPoly;
									thisMeshPolys[k] = (tmpPoly as array);
									--print "poly is better then old one ----> EXIT";
									print " !!! WARNING !!! -- found Poly that holds one of the already stored polys but is bigger -> it has more faces.. this could cause errors!!!!"
									exit;
									
								)
							)
						)
						
						if tmpFoundMatch == false then (
							-- print "--> new poly found !!";
							append thisPolyBit_array tmpPoly ;
							append thisMeshPolys (tmpPoly as array) ;
							
							-- this function is very complex .. maybe find a better solution
							setPolyEdgeVis exportMesh (tmpPoly as array);
						)
						--else print "i already have this poly stored";
					)
					poly_array[eMeshCounter] = thisMeshPolys;
					
					print "old poly_array";
					print thisMeshPolys;
					*/
					poly_array[eMeshCounter] = getPolyArray exportMesh;
					
					
				
					
					
					
					-- create vertex array
					for j=1 to exportMesh.Verts.count do (
						-- ;P000=     _y     _z      _x      _b
						
						x = exportMesh.Verts[j].pos.x as integer;
						y = exportMesh.Verts[j].pos.y as integer;
						z = exportMesh.Verts[j].pos.z as integer;
						
						_b = thisSkinWeight_array[j]; -- 
						
						thisVerts_array[j] = ("  " + y as string + "   " +  z as string + "   " +  x as string + "   " +  _b as string);
						
						
						-- thisVertToComponent_array = [exportMesh.Verts[j]][_b]
						
						
					)
					vertsString_array[eMeshCounter] = thisVerts_array
					
					
					
					
					
					
					-- create polyVertex array for all polys
					PolyVerts_array[eMeshCounter] = getPolyVertexArray exportMesh poly_array[eMeshCounter];
					
					
					
					
					-- ################################
					-- for every poly of this mesh
					-- #########
					thisMeshPolys = poly_array[eMeshCounter];
					--print "thisMeshPolys";
					--print thisMeshPolys;
					
					
					
					for j=1 to thisMeshPolys.count do (
						
						--format "-> poly Nr. %\n" j 
						
						
						-- create polyVertex array
						-- for every face of this poly
						/*
						thisPolyVerts_array[j] = #();
						for k=1 to thisMeshPolys[j].count do(
							--format "---> face localNr.: % globalNr: %\n" k  thisMeshPolys[j][k];
							local p3 = getFace exportMesh thisMeshPolys[j][k];
							if p3.x < 1 or p3.y <1 or p3.z < 1 then (
								tmp = "!!! ERROR !!! - found face with less then 3 verts -- stopping export";
								print tmp;
								return tmp;
							)
							else 	local thisFaceVerts = #(p3.x as integer, p3.y as integer, p3.z as integer);
							
							for m=1 to 3 do (
								-- if vertex is not already part of the polyVertex_array -> store it
								if findItem thisPolyVerts_array[j] thisFaceVerts[m] == 0 then (
									append thisPolyVerts_array[j] thisFaceVerts[m];
								)
								--else print "---> vertex already in thisPolyVerts_array";
							)
						)
						
						print "old thisPolyVerts_array";
						print thisPolyVerts_array[j];
						*/
						-- get polyVertex array for this poly [j]
						thisPolyVerts_array[j] = PolyVerts_array[eMeshCounter][j];
						--print "new thisPolyVerts_array";
						--print thisPolyVerts_array[j];
						
						
						
						-- create polyInfo_array
						-- get material id from the first face of this poly
						thisPolyInfo_array[j] = #();
						(
							local tmpA = #();
							local tmpMatID = getFaceMatID exportMesh thisMeshPolys[j][1];
							
							if tmpMatID < 1000 then _actionCode = "";
							else (
								_actionCode = substring (tmpMatID as string) 1 3 + " " + substring (tmpMatID as string) 4 -1;
								 --format " _actionCode = % \n" _actionCode;
								if _actionCode == undefined then _actionCode = "";
							)
							tmpA[1] = _actionCode;
							
							-- smoothingGroup data is stored as 32bit integer !! more info at the import part
							_elementType = getFaceSmoothGroup exportMesh thisMeshPolys[j][1]
							-- format " _elementType = % \n" _elementType;
							_elementType = ((log _elementType / log 2) as integer + 1) as string ;
							-- format " _elementType = % \n" _elementType;
							tmpA[2] = _elementType;
							
							thisPolyInfo_array[j] = tmpA;
						)
							
						
						
						
						-- create thisPolyToComponent_array
						-- saves for every poly the Component ID it belongs to, this is needed for the normals-part
						for k=1 to thisMeshPolys[j].count do(
							local tmp1 = 0;
							local tmp2 = 0;
							local notPure = false;
							-- for every vert
							for m=1 to (thisPolyVerts_array[j].count-1) do (
								tmp1 = thisSkinWeight_array[ thisPolyVerts_array[j][k] ];
								tmp2 = thisSkinWeight_array[ thisPolyVerts_array[j][k+1] ];
								--print tmp1;
								--print tmp2;
								--tmp1 -= 1;
								--tmp2 -= 1;
								if tmp1 != tmp2 then (notPure = true; exit;)
							)
							-- if all verts of this poly belong to the same Component save its ID
							-- if not assign them to the rootBone
							-- THIS could maybe couse trobble if a poly belongs to 2 different Components but NOT to the rootBone
							if notPure then (
								thisPolyToComponent_array[j] = 0; -- assign to rootBone
							)
							else thisPolyToComponent_array[j] = tmp1; -- == tmp2;
						)
						
						--print " _ _ _thisPolyToComponent_array";
						--print thisPolyToComponent_array;
						
						
						
						-- create normals array
						-- get normal of first face and store in normals_array (every face of the poly has the same normal as the poly itself
						thisNormals_array[j] = getFaceNormal exportMesh thisMeshPolys[j][1];
						
						-- calculate EAW normal values
						--thisNormals_array[j].x *= 16384;
						--thisNormals_array[j].y *= 16384;
						--thisNormals_array[j].z *= 16384;
						
						
						-- get center of all poly-vertices
						-- arithmetic mean
						-- vertex_array
						local centerOfThisPoly;
						(
							local tmpX = 0;
							local tmpY = 0;
							local tmpZ = 0;
							
							for k=1 to thisPolyVerts_array[j].count do (
								local p3 = 	meshop.getVert exportMesh thisPolyVerts_array[j][k];
								tmpX += p3.x as integer;
								tmpY += p3.y as integer;
								tmpZ += p3.z as integer;
							)
							tmpX /= thisPolyVerts_array[j].count;
							tmpY /= thisPolyVerts_array[j].count;
							tmpZ /= thisPolyVerts_array[j].count;
							
							centerOfThisPoly = point3  tmpX  tmpY  tmpZ;
						)
						
						
						local tmp_Norm_Ar;
						tmp_Norm_Ar = (makeEawNormal [thisNormals_array[j].x, thisNormals_array[j].y, thisNormals_array[j].z]  [centerOfThisPoly.x, centerOfThisPoly.y, centerOfThisPoly.z] normalExportFormat);
						
						
						-- _y0    _z0    _x0     _d     _c     _f
						id = MakeNumber (j-1);
						_x0 = tmp_Norm_Ar[1] as string;
						_y0 = tmp_Norm_Ar[2] as string;
						_z0 = tmp_Norm_Ar[3] as string;
						
						-- format "_De = % .. _cd = % .. _d = % .. _c = % .. \n" _De _cd _d _c;
						
						_f = thisPolyToComponent_array[j] as string;
						
						-- the id Nxxx is addes later 
						local _De;
						_De = tmp_Norm_Ar[4] as string;
						
						thisNormalString_array[j] = " " + _y0 + "      " + _z0 + "      " +  _x0 + "      " + _De + "      " + _f ;
						
					) -- END _ for every poly
					normalString_array[eMeshCounter] = thisNormalString_array;
					polyUV_array[eMeshCounter] = thisPolyUV_array;
					polyInfo_array[eMeshCounter] = thisPolyInfo_array;
					--polyVerts_array[eMeshCounter] = thisPolyVerts_array;
					
					
					--print "mesh = ";
					finalExportMesh = exportMesh;
					--print finalExportMesh
					--print exportMesh
					--print "-"
					
				) -- END of "is  Editable_mesh "
				
				
				
			)
			else (
				errorM = "!! ERROR !! -- object " + selection[i] + "  is NO valid node";
				print errorM;
				return errorM;
			)
			
			
		) -- END for
		
		-- this is going to be the INSERT part
		--print " _ dummyString_array";
		--print dummyString_array;
		
		-- this is going to be the NORMALS part
		--print " _ normalString_array";
		--print normalString_array;
		
		-- the POINT section will be created out of verts_array, hardpoint_array and line_array
		
		--print " _ vertsString_array";
		--print vertsString_array;
		
		
		
		
		-- order hardpoint array 
		print " _ tmpHardpointArray";
		print tmpHardpointArray;
		for i=1 to tmpHardpointArray.count do (
			local foundMatch = false;
			local L = tmpHardpointArray.count;
			for k=1 to L do (
				if tmpHardpointArray[k][4] == i then (
					hardpoint_array[L + 1 - i] = tmpHardpointArray[k];
					foundMatch = true;
					exit;
				)
			)
			if foundMatch == false then print "!!! ERROR !!! - Hardpoints are not numbered correctly";
		)
		print " _ hardpoint_array";
		print hardpoint_array;
		
		
		-- the ELEMENT section will be created out of polyElement_array, hardpoint_array, line_array
		
		-- stores the ids of all faces which form one poly
		--print " _ poly_array[1]";
		--print poly_array[1];
		
		-- stores the ids of all vertexes which form one poly
		--print " _ polyVerts_array[1]";
		--print polyVerts_array[1];
		
		--print " _ polyUV_array[1]";
		--print polyUV_array[1];
		
		
		--print " _ polyInfo_array";
		--print polyInfo_array;
		
		
		
		
		
		
		
		print "########################################";
		print "______________ PREPARE export ARRAYS"
		print "########################################"
		
		-- !!! Important !!! 
		-- just eMesh data 1 is going to be used 
		-- => vertsString_array[1] <-- 1 not <n>
		
		
		finalINSERT_array = #();
		finalNORMAL_array = #();
		finalSEQUENCE_array = #();
		finalPOINTS_array = #();
		finalELEMENTS_array = #();
		
		
		
		-- INSERT 
		-- already final : dummyString_array
		finalINSERT_array = dummyString_array;
		/*
		for i=1 to dummyString_array.count do(
			finalINSERT_array[i] = "I" + (MakeNumber (i-1)) + "  " + dummyString_array[i];
		)
		*/
		
		
		-- POINTS
		-- first add eMesh verts
		counterPOINTS = -1;
		hardpointPOINTid = #();
		for i=1 to vertsString_array[1].count do(
			counterPOINTS += 1;
			-- add ID
			tmp = "P" + (MakeNumber counterPOINTS) + "= " + vertsString_array[1][i];
			append finalPOINTS_array tmp;
		)
		-- 2nd add hardpoint verts (from point helper objects)
		for i=1 to hardpoint_array.count do (
			counterPOINTS += 1;
			-- create POINT entry
			x=hardpoint_array[i][2].x as integer;
			y=hardpoint_array[i][2].y as integer;
			z=hardpoint_array[i][2].z as integer;
			_b = 0;
			
			tmp = ("P" + (MakeNumber counterPOINTS) + "= " + y as string + "   " +  z as string + "   " +  x as string + "   " +  _b as string);
			append finalPOINTS_array tmp;
			
			append hardpointPOINTid counterPOINTS;
			
		)
		--print "hardpointPOINTid =";
		--print hardpointPOINTid;
		-- 3rd add line verts
		--##
		--##
		if counterPOINTS > 254 then return "!!! ERROR !!! -- too many Points (max 255)"; 
		
		
		
		-- ELEMENTS + NORMALS + SEQUENZE
		-- ___________________
		-- first add eMesh elements (line data is stored here too)
		-- ___________________
		counterELEMENTS = -1;
		for i=1 to poly_array[1].count do (
			counterELEMENTS += 1;
			
			local thisElementNumber = (MakeNumber counterELEMENTS);
			
			tmpPolyVertsArray = ( getVertOrder finalExportMesh poly_array[1][i]) ;
			if tmpPolyVertsArray[1] == "!" then (return "ERROR -- use maxscript console to find out more";)
			if tmpPolyVertsArray.count < 3 then (return "ERROR -- bad polygon";)
			
			_id = "E" + thisElementNumber + "= ";
			
			_actionCode = polyInfo_array[1][i][1] as string;
			_elementType = polyInfo_array[1][i][2] as string;
			-- OLD --_vertexCount = polyVerts_array[1][i].count as string
			_vertexCount = tmpPolyVertsArray.count as string;
			
			-- reverse it 
			tmpPolyVertArrayReversedOld = #();
			tmpPolyVertArrayReversedOld = for j = polyVerts_array[1][i].count to 1 by -1 collect polyVerts_array[1][i][j];
			tmpPolyVertArrayReversed = #();
			tmpPolyVertArrayReversed = for j = tmpPolyVertsArray.count to 1 by -1 collect tmpPolyVertsArray[j];
			
			/*
			print "--------------------------------------------------------------------------------------------------------";
			print "###";
			--print " _ old PolyVertArray :: "
			--print tmpPolyVertArrayReversedOld
			print " _ new PolyVertArray :: ";
			print tmpPolyVertArrayReversed;
			print "----------------------------------------";
			*/
			
			_colourIndex = "101"; -- tmp value
			_0Flag = "0"; -- 0 Flag must be removed if piggyback elements are added
			_PiggybackData = ""; -- tmp value this 
			_endOfLine = "255";
			
			-- create nodeData string
			-- elements supported: 
			-- 1 (line) (not supported)
			-- 2 (hardpoint)
			-- 3 (single colored poly)
			-- 4 (multi colored poly)
			-- 5 (textured poly)
			-- 6 (textured poly with alpha)
			-- 15 (bulkhead elements)
			
			_nodeData = "";
			tmp = ""; -- clear tmp value first
			
			-- NOT SUPPORTED ELEMENT TYPES (including lines)
			if (_elementType as integer < 2 or _elementType as integer > 6) and  _elementType as integer != 15 then (
				tmp = _id + "   ; ERROR :: Element uses unsupported element code: " + _elementType as string+ " (supported codes are 2, 3, 4, 5, 6,)";
				print tmp;
			)
			
			-- 15 BULKHEADS (removed)
			if _elementType == "15" and removeBulkheads == 1 then (
				tmp +=  _id + "   " + "255";
			)
			
			-- 2 HARDPOINTS - 3 SINGLE COLORED POLYS - 15 BULKHEADS (not removed)
			-- about hardpoints:
				--this is for (real) polys which use the smoothing group 2
				-- this has nothing to do with the helper point objects that can also be used to set hardpoints
			if _elementType == "2" or _elementType == "3" or ( _elementType == "15" and removeBulkheads == 0 ) then (
				
				-- +++
				for j=1 to _vertexCount as integer do (
					_nodeData += "   " + (tmpPolyVertArrayReversed[j] - 1) as string;
				)
				-- +++
				
				if _elementType == "2" then ( -- if poly is used as hardpoint add hardpoint code as piggyback
					_PiggybackData = _elementType + "   " + "<set hardpoint Code here>"  + "   " +  (tmpPolyVertArrayReversed[1] - 1) as string;
				)
				
				local _bulkheadCode = "";
				if _elementType == "15" then ( -- bulkeads which should not be removed are marked with a special colourIndex 
					_colourIndex = "641";
					_bulkheadCode = ""; -- does not work with txt to 3dz converter
					
				)
				tmp = tmp + _id + "   " + _actionCode + "   " + "3" + "   " + _vertexCount + "   " + _nodeData + "   " + _colourIndex + "   " + _PiggybackData + "   " + _endofLine + "" + _bulkheadCode ;
			)
			
			-- 4 MULTICOLORED POLYS
			if _elementType == "4" then (
				for j=1 to _vertexCount as integer do (
					_nodeData += "   " + (tmpPolyVertArrayReversed[j] - 1) as string + "   " +  _colourIndex;
				)
				tmp = _id + "   " + _actionCode + "   " + _elementType + "   " + _vertexCount + "   " + _nodeData + "   "  +  "   " + _PiggybackData + "   " + _endofLine;
			)
			
			-- 5&6 TEXTURED POLYS WITH OR WITHOUT ALPHA
			if _elementType == "5" or _elementType == "6" then (
				for j=1 to _vertexCount as integer do (
					-- node data old --_nodeData += "   " +  (tmpPolyVertArrayReversed[j] - 1) as string + "   " + polyUV_array[1][i][j][1] as string + "   " + polyUV_array[1][i][j][2] as string + "   ";
					local tmpUV = ( getUVfromPolyVert finalExportMesh poly_array[1][i] tmpPolyVertArrayReversed[j] );
					_nodeData += "   " +  (tmpPolyVertArrayReversed[j] - 1) as string + "   " + (tmpUV.x as integer) as string + "   " + (tmpUV.y as integer) as string + "   ";
				)
				tmp = _id + "   " + _actionCode + "   " + _elementType + "   " + _vertexCount + "   " + _nodeData + "   " + _0Flag + "   " + _colourIndex + "   " + _PiggybackData + "   " + _endofLine;
			)
			
			append finalELEMENTS_array tmp;
			
			
			-- add NORMALS string
			-- check if is an hardpoint or a normal poly
			_id = "N" + thisElementNumber + "= ";
			if _elementType == 2 then (
				-- atm do the same.. 
				-- but _should_ change the _f value to -32768
				tmp = _id + "   " + normalString_array[1][i];
			)
			else (
				
				tmp = _id + "   " + normalString_array[1][i];
			)
			append finalNORMAL_array tmp;
			
			-- add SEQUENZE string
			_id =  "S" + thisElementNumber + "= ";
			_back = "255"; --tmp value
			_front = "255"; --tmp value
			
			tmp = _id + "   " + _back + "   " + _front;
			append finalSEQUENCE_array tmp;
			
		)
		-- ___________________
		-- 2nd add hardpoint elements (using point helper objects)
		-- ___________________
		for  i=1 to hardpoint_array.count do (
			local tmp; -- !!!!!! does this work?
			
			counterELEMENTS += 1;
			local thisElementNumber = (MakeNumber counterELEMENTS);
			
			-- add HARDPOINT ELEMENTS string
			_id = "E" + thisElementNumber + "= ";
			_elementType = "2";
			_index = hardpoint_array[i][1] as string;
			_nodeID = hardpointPOINTid[i] as string;
			_endOfLine = "255";
			
			tmp = _id + "   " + _elementType + "   " + _index + "   " + _nodeID + "   " +  _endOfLine;
			append finalELEMENTS_array tmp;
			
			
			-- get the hardpoint normal values
			local hp_normal;
			local hp_origin;
			local tmp_hpN_Ar;
			local theDstring;
			
			hp_normal = hardpoint_array[i][3];
			hp_origin = hardpoint_array[i][2];
			
			tmp_hpN_Ar = (makeEawNormal hp_normal hp_origin normalExportFormat);
			
			-- add HARDPOINT NORMALS string
			_id = "N" + thisElementNumber + "= ";
			_x0 = tmp_hpN_Ar[1] as string;
			_y0 = tmp_hpN_Ar[2] as string;
			_z0 = tmp_hpN_Ar[3] as string;
			--_d = "0";
			--_c = "0";
			theDstring = tmp_hpN_Ar[4] as string;
			_f = "-32768";
			
			tmp = _id + "   " + _y0 + "      " + _z0 + "      " +  _x0 + "      " + theDstring + "      " + _f;
			append finalNORMAL_array tmp;
			
			-- add HARDPOINT SEQUENZE string
			_id =  "S" + thisElementNumber + "= ";
			_back = "255" --tmp value
			_front = "255" --tmp value
			
			tmp = _id + "   " + _back + "   " + _front;
			append finalSEQUENCE_array tmp;
		)
		if counterELEMENTS > 254 then return "!!! ERROR !!! -- too many Elements (max 255)";
		
		
		
		-- RENDER SEQUENCE CALULATION
		
		my_RStree = undefined;
		if calculateRS == 1 then (
			print finalExportMesh;
			print hardpoint_array;
			print mainCutPlane;
			my_RStree = RS_makeRS finalExportMesh hardpoint_array #(mainCutPlane);
		)
		
		
		
		--print "finalINSERT_array = ";
		--print finalINSERT_array;
		
		--print "finalNORMAL_array = ";
		--print finalNORMAL_array;
		
		--print "finalSEQUENCE_array =";
		--print finalSEQUENCE_array;
		
		--print "finalPOINTS_array =";
		--print finalPOINTS_array;
		
		--print "finalELEMENTS_array =";
		--print finalELEMENTS_array;
		
		
		
		
		
		print "########################################";
		print "______________ create EXPORT STRING"
		print "########################################"
		
		
		
		
		
		-- PREAMBLE
		exportstring = ";file created with 'mgto EAW export script'
;(http://till.maginot.eu)
;
;
;stuff which does not work at the moment
; - face duplicates
; - lines
; - colour index
; - piggybacks
";
		
		-- HEADER 
		
		_INI = headerStuffArray[1];
		_TEXTURE = headerStuffArray[2];
		_PARTS = finalINSERT_array.count + 1;
		_POINTS = finalPOINTS_array.count;
		_ELEMENTS = finalELEMENTS_array.count;
		_PREVIEW = headerStuffArray[3];
		
		exportstring += "\n\n\n[HEADER]
INI=" + _INI + "
TEXTURE=" + _TEXTURE + "
PARTS=" + _PARTS as string + "
POINTS=" + _POINTS as string + "
ELEMENTS=" + _ELEMENTS as string + "
; place here the preview bitmap file's name. Useful to 3dz library
PREVIEW=" + _PREVIEW + "
[END]";

		
		-- [INSERT]		
		exportstring += "\n\n\n[INSERT]
;I000=_cod _num   _y   _z    _x";
		if finalINSERT_array.count > 0 then (
			for i=1 to finalINSERT_array.count do (
				exportstring += "\n" + finalINSERT_array[i] as string;
			)
		)
		exportstring += "\n[END]"
		
		
		-- [NORMALS]
		if normalExportFormat == 1 then (
			exportstring += "\n\n\n[NORMAL]
;N000=   _y0    _z0    _x0     _d     _c     _f";
		)
		if normalExportFormat == 2 then (
			exportstring += "\n\n\n[NORMAL]
;N000=   _y0    _z0    _x0     _D     _f";
		)
		
		for i=1 to finalNORMAL_array.count do (
			exportstring += "\n" + finalNORMAL_array[i] as string;
		)
		exportstring += "\n[END]"
		
		
		
		--[SEQUENCE]
		exportstring += "\n\n\n[SEQUENCE]";
		if my_RStree == undefined then (
			exportstring += ";S000= drawLast drawFirst
;the first line is the start point of rendering sequence
S000=    255   0";
			for i=1 to finalSEQUENCE_array.count do (
				exportstring += "\n" + finalSEQUENCE_array[i] as string;
			)
		)
		else exportstring += my_RStree;
		exportstring += "\n[END]"
		
		-- [POINTS]
		exportstring += "\n\n\n[POINTS]
;P000=     _y     _z      _x      _b"
		for i=1 to finalPOINTS_array.count do (
			exportstring += "\n" + finalPOINTS_array[i] as string;
		)
		exportstring += "\n[END]"
		
		
		-- [ELEMENTS]
		exportstring += "\n\n\n[ELEMENTS]
;E000= data end_code";
		for i=1 to finalELEMENTS_array.count do (
			exportstring += "\n" + finalELEMENTS_array[i] as string;
		)
		exportstring += "\n[END]"
		
		
		
		exportstring += "\n\n\n; end of this file
[EOF]";
		
		
		
		
		
		
		print "########################################";
		print "___SAVE export STRING to FILE and RELOAD MAX SCENE"
		print "########################################"
		
		--___________________
		-- file handler
		
		out_file = createfile filename2;
		
		format exportstring to:out_file;
		
		close out_file;
		
		--___________________

		
		-- load saved max file
		
		tmp = loadMaxFile tmpFilename useFileUnits:true quiet:false;

		if tmp then (
			print "file reloaded";
			messagebox "Model exported!";
		)
		else print "file not reloaded";
		
		
	) -- END if sceneWasSaved
	else print "stopping export function";
)-- END function exportTXT


-- ###################################################################







-- +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

/*
-- romove this one day...
global eawimport;
global headerInfo;
global eawexport;
*/
local headerInfo;


function _init = (
	print "EAW 3dz TOOLS for MAXSCRITP :: LOADED";
)

_init();



-- IMPORT
rollout eawimport "import from EAW 1.8a_txt " width:162 height:91 (
	-- Define the UI
	edittext filenameTxt "" pos:[10,15] width:140 height:18 fieldwidth:200 labelOnTop:true readOnly:false

	button buttonGetFilename "get url" pos:[10,40] width:40 height:18

	button buttonImport "Import" pos:[55,40] width:95 height:18

	GroupBox grp1 "Import" pos:[5,0] width:150 height:83

	-- Get the File name of the TXT-File for importing
	-- Call the import Funktion
	
	checkbox dellIsolVerts "remove unused nodes" pos:[15,64] width:130 height:15;
	
	
	
	on buttonGetFilename pressed do
	(
			local tmp = getOpenFileName types:"3dz-txt (*.txt)|*.txt|All|*.*|" ;
			if tmp != undefined then filenameTxt.text = tmp as string;
		)
	on buttonImport pressed do
	(
			import_settings = #(dellIsolVerts.triState);
		
			if filenameTxt.text == undefined or filenameTxt.text == "" then (
				messagebox "use 'get url' first"
			)
			else (
				undo off ( messagebox ( importTXT filenameTxt.text import_settings);)
			)
		)
)


 -- EXPORT
 rollout eawexport "export to EAW 1.8a_txt" width:160 height:230
 (
	
 	edittext filename2Txt "" pos:[10,15] width:140 height:18 fieldwidth:200 labelOnTop:true readOnly:false
 	button buttonSetFilename "set url" pos:[10,40] width:40 height:18
 	button buttonExport "Export Selection" pos:[55,40] width:95 height:18
 	GroupBox grp1 "Export" pos:[5,0] width:150 height:102
 	dropdownList ddlNormalExportFormat "" pos:[10,193] width:140 height:21 items:#("use _d and _c", "use _D") selection:1
 	GroupBox grp3 "Normals Mode" pos:[5,176] width:150 height:45
 	checkbox cbRomoveBulkheads "Irreversible remove Bulkheads (sg15)" pos:[15,64] width:119 height:27
 	checkbox cbMakeRS "Calculate RS on export" pos:[14,122] width:137 height:18
 	
	 
 	GroupBox grp2 "Render Sequence" pos:[6,106] width:148 height:65

	 -- !!! MAIN CUT PLANE == mainAxis
 	label lbl1 "main Cut Plane" pos:[13,145] width:80 height:20

 	dropdownList ddmainAxis "" pos:[88,142] width:60 height:21 items:#("NONE", "XZ", "XY", "YZ")

	 
	 
	 
	-- Get the File name of the TXT-File for exporting
	
	-- Call the import Funktion
 	
	
 	on buttonSetFilename pressed do
 	(
		local tmp = getSaveFileName types:"3dz-txt (*.txt)|*.txt|All|*.*|" ;
		if tmp != undefined then filename2Txt.text = tmp as string;
	)
	
	
 	on buttonExport pressed do
 	(
 			
		mainAxis = [0,0,0];
		if ddmainAxis.selected == "NONE" then mainAxis = "none";
		if ddmainAxis.selected == "XZ" then mainAxis = [0,1,0];
		if ddmainAxis.selected == "XY" then mainAxis = [0,0,1];
		if ddmainAxis.selected == "YZ" then mainAxis = [1,0,0];
	
	
	
	
	
		if filename2Txt.text == undefined or filename2Txt.text == "" then (
			messagebox "use 'set url' first";
		)
		else (
		if ddlNormalExportFormat.selection == undefined then (
			messagebox "dropdown Normals Mode value not set";
		)
		else (
			-- messagebox (ddlNormalExportFormat.selection as String);
			handoverHeaderArray = #(headerInfo.headerINI.text,  headerInfo.headerTEX.text, headerInfo.headerPREVIEW.text)
			
			_settings = #(ddlNormalExportFormat.selection, cbRomoveBulkheads.triState, cbMakeRS.triState, mainAxis);
			
			undo off ( print ( exportTXT filename2Txt.text _settings handoverHeaderArray);)
		)
		)
	)
 )



rollout headerInfo "HEADER" width:162 height:234 (
	-- INI
	edittext headerINI "" pos:[10,20] width:140 height:18 fieldwidth:100 labelOnTop:true readOnly:false
	-- Texture
	edittext headerTEX "" pos:[10,95] width:140 height:18 fieldwidth:200 labelOnTop:true readOnly:false
	-- Preview
	edittext headerPREVIEW "" pos:[10,170] width:140 height:18 fieldwidth:200 labelOnTop:true readOnly:false
	
	groupBox grp2 "INI" pos:[5,5] width:150 height:65;
	groupBox grp3 "TEXTURE" pos:[5,80] width:150 height:65;
	groupBox grp4 "PREVIEW" pos:[5,155] width:150 height:65;
	
	button buttonCalculateINI "calculate radius from mesh" pos:[10,45] width:140 height:18;
	button buttonGetTexture "get texture from selection" pos:[10,120] width:140 height:18;
	button buttonGetPreview "get name from file" pos:[10,195] width:140 height:18;

	on buttonCalculateINI pressed do (
		local maxDistance = 0;
		if selection.count > 1 then ( headerInfo.headerINI.text = "Err: select only one Mesh";)
		else (
			if isValidNode selection[1] then (
				if classof selection[1] == Editable_mesh or classof selection[1] == PolyMeshObject or classof selection[1] == Editable_Poly then (
					
					for i=1 to getNumVerts selection[1] do (
						if classof selection[1] == Editable_mesh then (
							local p3 = getVert selection[1] i;
						)
						if classof selection[1] == PolyMeshObject or classof selection[1] == Editable_Poly then (
							local p3 = selection[1].GetVertex i;
						)
						print p3;
						-- length of 0-vector
						thisDistance = sqrt (pow p3.x 2 + pow p3.y 2 + pow p3.z 2)
						if thisDistance > maxDistance then maxDistance = thisDistance;
					)
					
					maxDistance += 1; --security value
					maxDistance = ceil maxDistance;
					headerInfo.headerINI.text = (maxDistance as integer) as string;
				)
				else headerInfo.headerINI.text = "Err: select Editable_mesh or Editable_Poly";
			)
			
		)
	)
	
	on buttonGetTexture pressed do (
		if isValidNode selection[1] then (
			if selection[1].material != undefined then (
				local tmp = (filterString ($.material as string) ":");
				if tmp[2] == "Standard" then (
					local materialName = (filterString ($.material.diffuseMap as string) ":");
					headerInfo.headerTEX.text = materialName[1];
				)
				else headerInfo.headerTEX.text = "Err: no standard material";
			)
			else headerInfo.headerTEX.text = "noMaterial";
		)
	)
	
	on buttonGetPreview pressed do (
		tmp = getOpenFileName();
		local tmpPreviewURL = filterstring tmp "\\";
		headerInfo.headerPREVIEW.text = tmpPreviewURL[tmpPreviewURL.count];
	)


)
 

rollout RS_stuff "Render Sequence" width:162 height:200 (
	
	button buttonMakeRS "Check Selection" pos:[10,20] width:140 height:18;


	button buttonCheckCoplanar "select concave polys" pos:[10,100] width:140 height:18;

	--button buttoncheckAxis "check Axis" ;
	-- !!! MAIN CUT PLANE == mainAxis
	label lbl1 "main Cut Plane" pos:[12,49] width:80 height:20;
	dropdownList ddmainAxis "" pos:[90,46] width:60 height:21 items:#("NONE", "XZ", "XY", "YZ");
	
	
	
	GroupBox grp1 "Calculate RS" pos:[5,5] width:150 height:70;
	GroupBox grp2 "Error checking" pos:[5,85] width:150 height:42;
	


	on buttonMakeRS pressed do
	(
		local meshcounter = 0;
		local tmpHardpointArray = #();
		local my_Mesh;
		
		for i=1 to selection.count do (
			
			-- POINT == HARDPOINT
			if classof selection[i] == Point then (
				-- create hardpoint array
				print "found hardpoint";
				append tmpHardpointArray (getHPinfo selection[i]);
				
				
				
			)
			else (
				if classof selection[i] == Editable_mesh then (
					print "found Editable_Mesh";
					meshcounter += 1;
					my_Mesh = selection[i]
					-- check if only one mesh is selcted
				)
				else format "unsupported object ( % ), dropping it... \n" selection[i] ;
			)
		)	
		if meshcounter > 0 and meshcounter < 2 then (
			
			
				mainAxis = [0,0,0];
				if ddmainAxis.selected == "NONE" then mainAxis = "none";
				if ddmainAxis.selected == "XZ" then mainAxis = [0,1,0];
				if ddmainAxis.selected == "XY" then mainAxis = [0,0,1];
				if ddmainAxis.selected == "YZ" then mainAxis = [1,0,0];
				
				local hardpointArray = #();
				
				-- order hardpoint array 
				for i=1 to tmpHardpointArray.count do (
					local foundMatch = false;
					local L = tmpHardpointArray.count;
					for k=1 to L do (
						if tmpHardpointArray[k][4] == i then (
							hardpointArray[L + 1 - i] = tmpHardpointArray[k];
							foundMatch = true;
							exit;
						)
					)
					if foundMatch == false then print "!!! ERROR !!! - Hardpoints are not numbered correctly";
				)
				
				print "tmpHardpointArray";
				print tmpHardpointArray;
				print "hardpointArray";
				print hardpointArray;
				
				my_RStree = RS_makeRS my_Mesh hardpointArray #(mainAxis);
				
				format "\n \n % \n" my_RStree;
			
			--else print "!!! ERROR !!! - no Editable_Mesh :: please select ONE Editable_Mesh and all hardpoints";
			
		)
		else print "!!! ERROR !!! - wrong Mesh count :: please select ONE Editable_Mesh and all hardpoints";
	)
	
	
	
	on buttonCheckCoplanar pressed do
	(
		if ($ as string) == "$selection" then (
			print "!!! ERROR !!! - please select only one object";
		)
		else if IsValidNode $ then (
			my_Mesh = $;
			
			if classof my_Mesh == XRefObject then (
				--my_Mesh = snapshotAsMesh my_Mesh;
			)
			
			if classof my_Mesh == Editable_mesh then (
				
				my_PolyArray = #(); -- stores the facesID's of every poly
				my_PolyArray = getPolyArray my_Mesh;
				--print  my_PolyArray;
				
				-- deselect all first;
				my_Mesh.selectedfaces=#{};
				
				badPolyFaces = RS_check_mesh_coplanar my_Mesh my_PolyArray;
				if badPolyFaces.count > 0 then (
					my_Mesh.selectedfaces=badPolyFaces;
					print "!!! WARNING !!! - found non coplanar poly(element), check your face-selection to see which!";
				)
				else print "all polys are coplanar, that's a good thing!";
				
				
			)
			else if classof my_Mesh == PolyMeshObject or classof my_Mesh == Editable_Poly then (
				local polycount = getNumFaces my_Mesh;
				local badPolys = #();
				
				for i=1 to polycount do ( -- for every poly
					vertsOfPoly = polyOp.getFaceVerts my_Mesh i;
					
					local pointsCoords = #();
					for k=1 to vertsOfPoly.count do (
						pointsCoords[k] = polyOp.getVert my_Mesh vertsOfPoly[k]
					)
					
					if  RS_check_coplanar pointsCoords then (
						-- good poly
					)
					else append badPolys i;
				)
				
				if badPolys.count > 0 then (
					polyOp.setFaceSelection my_Mesh badPolys;
					print "!!! WARNING !!! - found non coplanar poly(element), check your face-selection to see which!";
				)
				else print "all polys are coplanar, that's a good thing!";
			)
			else 	print "!!! ERROR !!! - please select an Editable_Mesh or Editable_Poly object"
				
				
			
		)
	)
)


rollout aboutMe "About" width:162 height:187
(
	label lbl1 "Europen Air War" pos:[42,7] width:78 height:13
	label lbl2 "3dz-txt importer / exporter" pos:[20,25] width:121 height:13
	label lbl3 "by Till 'rollin' Maginot" pos:[33,43] width:96 height:13
	HyperLink link1 "till.maginot.eu" pos:[49,61] width:64 height:15 color:(color 0 0 0) hovercolor:(color 250 250 250) visitedcolor:(color 0 0 0) address:"http://till.maginot.eu"
	
	label lbl4 " 2009" pos:[61,81] width:40 height:13
	label lbl5 "v.0.9.2" pos:[61,98] width:40 height:13
	label lbl15 "3dz <-> txt converter " pos:[31,123] width:99 height:14
	label lbl16 "by Alessandro Borges" pos:[27,138] width:108 height:18

)


rollout teststuff "test stuff" (
	button buttonTestFunction1 "calculate edge distance";
	button buttonTestFunction2 "vertexOrderArray";
	button buttonTestFunction3 "setPolyEdgeVis"
	button buttonTestFunction4 "getEdgesBetween2Verts";
	button buttonTestFunction5 "vector 2 rotation 2 vector";
	button buttonTestFunction6 "get poly array";
	
	on buttonTestFunction1 pressed do (
		/*
		selectedFaces = (getFaceSelection selection[1]) as array;
		print " _ selectedFaces ::";
		print selectedFaces;
		
		for i=1 to selectedFaces.count do (
			
			vertsOfThisFace = getFace selection[1] selectedFaces[i];
			print "vertsOfThisFace :: ";
			print vertsOfThisFace;
			
			for j=1 to 3 do (
				format "checking edge % :: \n" j;
				print (getEdgeVis selection[1] selectedFaces[i] j);
			)
		)
		*/
		
		/*
		local selectedVerts = (getVertSelection selection[1]) as array;
		print " _ selectedVerts ::";
		print selectedVerts;
		
		for i=1 to selectedVerts.count do (
			format "distance from % to % :: \n" selectedVerts[1] selectedVerts[i];
			print (meshop.minVertexDistanceFrom selection[1] selectedVerts[1] selectedVerts[i]);
		)
		*/
	)
	
	on buttonTestFunction2 pressed do (
		getVertOrder selection[1] ( (getFaceSelection selection[1]) as array );
	)
	
	on buttonTestFunction3 pressed do (
		setPolyEdgeVis selection[1] ( (getFaceSelection selection[1]) as array );
	)
	
	on buttonTestFunction4 pressed do (
		getEdgesBetween2Verts selection[1] ( (getVertSelection selection[1]) as array );
	)
	on buttonTestFunction5 pressed do (
		
		
		-- IMPORTANT: to test this here you need 2 objects $Du1 and $Du2
		
		-- vector 2 rotation
		
		anglesA = normal2rotation $Du1.pos;
		
		rot_x = anglesA[2];
		rot_y = 0;
		rot_z = anglesA[1];
		
		hardpoint = PointHelperObj name:(uniquename ("Hardpoint_") ) rotation:(eulerangles 0 0 0) pos:[0,0,0]  axistripod:true cross:true centermarker:true;
		rotate hardpoint (eulerangles 0 0 rot_z);
		in coordsys local rotate hardpoint (eulerangles rot_x 0 0 );
		
		
		
		
		
		-- rotation 2 vector
		
		local testdummy
		testdummy = $Du2
		
		testdummy.pos = (rotation2normal hardpoint);
		
		testdummy.pos.x *= 80;
		testdummy.pos.y *= 80;
		testdummy.pos.z *= 80;
	)
	
	on buttonTestFunction6 pressed do (
		myPolys = (getPolyArray $);
		print "myPolys array ::";
		print myPolys;
		myPolyVerts = getPolyVertexArray $ myPolys;
		print "myPolyVerts array ::";
		print myPolyVerts;
	)
	
)

objEd = newRolloutFloater "mgto EAW scripts" 175 600 10 100

addrollout eawimport objEd;

addrollout eawexport objEd;
addrollout headerInfo objEd;
headerInfo.open = false;
addrollout RS_stuff objEd;
--addrollout teststuff objEd;
addrollout aboutMe objEd;
aboutMe.open = false;


) -- CLOSE ALL